package com.malk.paineng.Timers;

import cn.hutool.core.date.DateTime;
import com.malk.paineng.controller.DDController;
import com.malk.paineng.service.GZT_PN;
import com.malk.paineng.service.YD_PN;
import com.malk.paineng.service.ZT_PN;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Contacts;
import com.malk.service.dingtalk.DDClient_Workflow;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Configuration
@EnableScheduling
public class timer1 {
    @Autowired
    private DDController Controller1;
    @Autowired
    private YD_PN yd_pnServer;
    @Autowired
    private ZT_PN zt_pnServer;
    @Autowired
    private DDClient ddClient;

    @Autowired
    private YDClient ydClient;
    @Autowired
    private GZT_PN gzt_pn;


    @Autowired
    private DDClient_Workflow ddClient_workflow;
    boolean ifss = true;

    //@Scheduled(fixedRate = 100)
    @Async
    @Scheduled(cron = "0 0 4 * * ?")
    public void LegalEntityList() throws Exception {

        if (true) {
            if (true) {
                log.info("开启派能数据同步！");
                System.out.println("开启派能数据同步！");
                if (true) {
                    zt_pnServer.ads_fin_gross_profit_margin_i();//收入毛利率分析
                    zt_pnServer.dwd_sal_ship_order_det_i();//瓦时数据
                    zt_pnServer.Purchasing_analysis();//采购明细
                    zt_pnServer.ads_fina_gen_accoutbook_detail_i();//只同步库数据, 先不同步指标
                    System.out.println("同步结束时间：" + DateTime.now());
                }
                if (false) {

                    yd_pnServer.syncYD_GSSJ();//工时-天数据  数据量太大暂不同步
                }
                System.out.println("派能数据同步结束！");

            }
        }
    }

    /**
     * 销售明细数据-凌晨6点执行
     */

 // @Scheduled(fixedRate = 100)
    @Async
  @Scheduled(cron = "0 0 6 * * ?")
    public void LegalEntityList_XSMX() throws Exception {
        if (true) {
                log.info("开启派能数据同步！销售明细");
                System.out.println("开启派能数据同步！");
                zt_pnServer.ads_fin_gross_profit_margin_i_XSMX();
                System.out.println("派能数据同步结束！销售明细");
        }
    }
    /**
     * 碳排放月度工时数据-凌晨4点执行
     */
    //@Scheduled(fixedRate = 500)
     @Async
    @Scheduled(cron = "0 0 4 * * ?")
    public void LegalEntityList_TPF() throws Exception {
        if (true) {
            log.info("开启碳排放月度工时同步！");
            System.out.println("开启碳排放月度工时同步！");
            yd_pnServer.syncYD_GSSJTOMonth();//碳排放月度工时数据
            System.out.println("碳排放月度工时同步结束！");
        }
    }



    /*批量删除宜搭表单数据  -运营平台数据*/
//    @Scheduled(fixedRate = 1000 )
//    public void DeleteYDData() {
//        log.info("开始批量删除宜搭数据");
//        System.out.println("开始批量删除宜搭数据");
//        try {
//            //一次100条，并非全部删除
//            DDR_New ddrNew = ydClient.queryData(YDParam.builder()
//                    .appType("APP_U3W7R66HBXPW5T4LETZ7")
//                    .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
//                    .formUuid("FORM-AE6B2FCDF9E244BB8C4EC2B8DFDBEFFAC6CN")
//                    .build(), YDConf.FORM_QUERY.retrieve_search_form_id);
//
//            System.out.println(ddrNew.getTotalCount());
//
//            ydClient.operateData(YDParam.builder()
//                    .appType("APP_U3W7R66HBXPW5T4LETZ7")
//                    .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
//                    .formUuid("FORM-AE6B2FCDF9E244BB8C4EC2B8DFDBEFFAC6CN")
//                    .asynchronousExecution(true)
//                    .formInstanceIdList((List<String>) ddrNew.getData())
//                    .build(), YDConf.FORM_OPERATION.delete_batch);
//            System.out.println("宜搭数据删除完毕！");
//
//        } catch (Exception e) {
//            //记录错误数据
//            e.printStackTrace();
//        }
//    }
    /*批量删除宜搭表单数据  -碳排放-上海*/
     @Scheduled(fixedRate = 500 )
    public void DeleteYDData() {
         yd_pnServer.syncYD_GSSJTOMonth();//碳排放月度工时数据

//        log.info("开始批量删除宜搭数据");
//        System.out.println("开始批量删除宜搭数据");
//        try {
//            //一次100条，并非全部删除
//            DDR_New ddrNew = ydClient.queryData(YDParam.builder()
//                    .appType("APP_U4GYY20ZKB7REZKT8586")
//                    .systemToken("9Z766DC19KWMUGCK7OQ8Z8UQ30YB2VVY74PYLCI3")
//                    .formUuid("FORM-A7F0FB903B7242F68FB99D6E81192C5B6BNE")//工时计算数据
//                    .build(), YDConf.FORM_QUERY.retrieve_search_form_id);
//
//            System.out.println(ddrNew.getTotalCount());
//
//            ydClient.operateData(YDParam.builder()
//                    .appType("APP_U4GYY20ZKB7REZKT8586")
//                    .systemToken("9Z766DC19KWMUGCK7OQ8Z8UQ30YB2VVY74PYLCI3")
//                    .formUuid("FORM-A7F0FB903B7242F68FB99D6E81192C5B6BNE")
//                    .asynchronousExecution(true)
//                    .formInstanceIdList((List<String>) ddrNew.getData())
//                    .build(), YDConf.FORM_OPERATION.delete_batch);
//            System.out.println("宜搭数据删除完毕！");
//
//        } catch (Exception e) {
//            //记录错误数据
//            e.printStackTrace();
//        }
    }


    /**
     * 常开
     * 工作台数据5分钟更新一次
 */
    @Async
    @Scheduled(cron = "0 */5 * * * ?")
    // @Scheduled(fixedRate = 500 )
    public void hzmhByType() {
        if (true) {
            try {
                log.info("工作台数据刷新开始！");
                gzt_pn.getDataList();
                log.info("工作台数据刷新结束！");
            } catch (Exception e) {
                // 记录错误信息
                e.printStackTrace();
                log.info("工作台数据异常: " + e.toString());
            }
        }
    }


    /**
     * 常开
     * 出差数据10分种同步到处理库
     */
    @Async
    @Scheduled(fixedRate = 1000 * 60 * 10)// 1000 * 60 * 10
    public void CCYdtoYd() {
        if (true) {
            try {
                log.info("出差数据写入宜搭开始！");
                if (true) {
                    yd_pnServer.CCSJtoYD();
                }

                if (false) {//抓取OA数据写入宜搭，不执行
                    String APP_EKY = "dingmpxci8bolc3jpima";
                    String APP_SECRET = "Y_k3jpKNHbGvb9S9As2Y61ZaUFNglm7SCqquIkcowLBRoc4ZpH7DG0ZTn8LyHMwI";
                    //派能出差PROC-83B26FB1-717C-4F64-B4C6-2869ED5C301E
                    //外出PROC-F7955C22-C8E6-45B1-B143-5518EF04EBF0
                    String token = ddClient.getAccessToken(APP_EKY, APP_SECRET);
                    String access_token = "PROC-83B26FB1-717C-4F64-B4C6-2869ED5C301E";
                    Calendar calendar = Calendar.getInstance();
                    calendar.add(Calendar.DAY_OF_YEAR, -42); // 设置为前120天的时间
                    long startTime = calendar.getTimeInMillis(); // 获取时间戳
//    Calendar calendarss = Calendar.getInstance();
//    calendarss.add(Calendar.DAY_OF_YEAR, -280); // 设置为前120天的时间
//    long endTime = calendarss.getTimeInMillis(); // 获取时间戳
                    long endTime = System.currentTimeMillis();
                    Map param_post = new HashMap();
                    // param_post.put("statuses","COMPLETED");//审批完成
//        param_post.put("startTime",startTime);
//        param_post.put("nextToken",nextToken);
//        param_post.put("maxResults",maxResults);
                    List<String> processData = (List<String>) ddClient_workflow.getInstanceIds_all(token, access_token, startTime, endTime, param_post);
                    System.out.println(processData);
                    if (processData != null && processData.size() > 0) {
                        for (int i = 0; i < processData.size(); i++) {

                            String sss = processData.get(i);
                            System.out.println("正在同步派能出差第:" + i + "/" + processData.size() + " 条数据!" + sss);
                            String obj_log = yd_pnServer.syncYD_PN(sss, "出差", "");

                        }
                    }
                }

                log.info("出差数据写入宜搭结束！");

            } catch (Exception e) {
                // 记录错误信息
                e.printStackTrace();
                log.info("出差数据写入宜搭异常: " + e.toString());
            }
        }
    }


//        log.info("k");
//        System.out.println("开始同步");
//        String APP_EKY = "dingmpxci8bolc3jpima";
//        String APP_SECRET = "Y_k3jpKNHbGvb9S9As2Y61ZaUFNglm7SCqquIkcowLBRoc4ZpH7DG0ZTn8LyHMwI";
//        try {//派能批量刷数据
//            System.out.println(DateTime.now()+"!开始同步派能出差:"+"B6CwTTjOTvK8UZOXPGXhQg01291728518733");
//            String obj_log= yd_pnServer.syncYD_PN("B6CwTTjOTvK8UZOXPGXhQg01291728518733", "出差" );
//
//            if (false) {
//                //派能出差PROC-83B26FB1-717C-4F64-B4C6-2869ED5C301E
//                //外出PROC-F7955C22-C8E6-45B1-B143-5518EF04EBF0
//                String token = ddClient.getAccessToken(APP_EKY, APP_SECRET);
//                String access_token = "PROC-83B26FB1-717C-4F64-B4C6-2869ED5C301E";
//                Calendar calendar = Calendar.getInstance();
//                calendar.add(Calendar.DAY_OF_YEAR, -10); // 设置为前120天的时间
//                long startTime = calendar.getTimeInMillis(); // 获取时间戳
////    Calendar calendarss = Calendar.getInstance();
////    calendarss.add(Calendar.DAY_OF_YEAR, -280); // 设置为前120天的时间
////    long endTime = calendarss.getTimeInMillis(); // 获取时间戳
//                long endTime = System.currentTimeMillis();
//                Map param_post = new HashMap();
//                // param_post.put("statuses","COMPLETED");//审批完成
////        param_post.put("startTime",startTime);
////        param_post.put("nextToken",nextToken);
////        param_post.put("maxResults",maxResults);
//                List<String> processData = (List<String>) ddClient_workflow.getInstanceIds_all(token, access_token, startTime, endTime, param_post);
//                System.out.println(processData);
//                if (processData != null && processData.size() > 0) {
//                    for (int i = 0; i < processData.size(); i++) {
//
//                        String sss = processData.get(i);
//                        System.out.println("正在同步派能出差第:" + i + "/" + processData.size() + " 条数据!" + sss);
//                         obj_log= yd_pnServer.syncYD_PN(sss, "出差" );
//
//                    }
//                }
//            }
//            if (false) {
//                String token = ddClient.getAccessToken(APP_EKY, APP_SECRET);
//                String access_token = "PROC-83B26FB1-717C-4F64-B4C6-2869ED5C301E";
//                Calendar calendar = Calendar.getInstance();
//                calendar.add(Calendar.DAY_OF_YEAR, -241); // 设置为前120天的时间
//                long startTime = calendar.getTimeInMillis(); // 获取时间戳
//                Calendar calendarss = Calendar.getInstance();
//                calendarss.add(Calendar.DAY_OF_YEAR, -121); // 设置为前120天的时间
//                long endTime = calendarss.getTimeInMillis(); // 获取时间戳
//                Map param_post = new HashMap();
//                List<String> processData = (List<String>) ddClient_workflow.getInstanceIds_all(token, access_token, startTime, endTime, param_post);
//                System.out.println(processData);
//                if (processData != null && processData.size() > 0) {
//                    for (int i = 0; i < processData.size(); i++) {
//                        String sss = processData.get(i);
//                        System.out.println("正在同步派能出差第:" + i + "/" + processData.size() + " 条数据!" + sss);
//                          obj_log= yd_pnServer.syncYD_PN(sss, "出差" );
//                    }
//                }
//            }
//            if (false) {
//                String token = ddClient.getAccessToken(APP_EKY, APP_SECRET);
//                String access_token = "PROC-83B26FB1-717C-4F64-B4C6-2869ED5C301E";
//                Calendar calendar = Calendar.getInstance();
//                calendar.add(Calendar.DAY_OF_YEAR, -363); // 设置为前120天的时间
//                long startTime = calendar.getTimeInMillis(); // 获取时间戳
//                Calendar calendarss = Calendar.getInstance();
//                calendarss.add(Calendar.DAY_OF_YEAR, -242); // 设置为前120天的时间
//                long endTime = calendarss.getTimeInMillis(); // 获取时间戳
//                Map param_post = new HashMap();
//                List<String> processData = (List<String>) ddClient_workflow.getInstanceIds_all(token, access_token, startTime, endTime, param_post);
//                System.out.println(processData);
//                if (processData != null && processData.size() > 0) {
//                    for (int i = 0; i < processData.size(); i++) {
//                        String sss = processData.get(i);
//                        System.out.println("正在同步派能出差第:" + i + "/" + processData.size() + " 条数据!" + sss);
//                          obj_log= yd_pnServer.syncYD_PN(sss, "出差" );
//
//                    }
//                }
//            }
//            System.out.println("同步结束");
//        } catch (Exception e) {
//            //记录错误信息
//            e.printStackTrace();
//        }
//    }


}
