package com.malk.paineng.controller;

import cn.hutool.core.date.DateTime;
import cn.hutool.json.JSONObject;
import com.alibaba.fastjson.JSON;
import com.malk.paineng.service.YD_PN;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Workflow;
import com.malk.utils.UtilDateTime;
import com.malk.utils.UtilMap;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.map.HashedMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.time.Duration;
import java.time.LocalDateTime;
import java.util.*;
import java.util.regex.Pattern;

@Slf4j
@RestController
@RequestMapping("oa")
public class DDController {
    @Autowired
    private YD_PN yd_pnServer;
    @Autowired
    private YDClient ydClient;

    @PostMapping("do-approve")//钉钉OA出差单数据同步到宜搭碳排放应用
    // public McR doApprove_PN(String processInstanceId, String type) {
    public McR doApprove_PN(@RequestBody JSONObject obj) throws IOException {

        String type = obj.get("type").toString();
        String processInstanceId = obj.get("processInstanceId").toString();
        if (type != "" && processInstanceId != "") {
            if (true) {
                Map hashMap = new HashMap();
                hashMap.put("textField_m3wod35r", processInstanceId);//processInstanceId
                hashMap.put("textField_m3wod35s", type);//type
                hashMap.put("textField_m3wod35t", "未同步" );//IF
                ydClient.operateData(YDParam.builder()
                        .appType("APP_Z4YYJI3LG8WXWY51L4B2")
                        .systemToken("KMC66FA18ZEQU27NCQKE3982F2JH3NF4NHM3MW2")
                        .formUuid("FORM-8E9F37B1CCD34F708D560ED0CF59CC27TW5C")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
            System.out.println(DateTime.now()   + processInstanceId+"写入宜搭待同步成功!");
        }
        return McR.success();
    }


}
