package com.malk.paineng.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.json.JSONArray;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

import com.malk.paineng.service.ZhongTai_All;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Workflow;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.CookieStore;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeParseException;
import java.util.*;
import java.util.Date;

import static java.sql.DriverManager.getConnection;

@Slf4j
@Service
public class ZhongTai_AllImpl implements ZhongTai_All {

    @Autowired
    private DDClient ddClient;

    @Autowired
    private YDClient ydClient;

    @Autowired
    private DDClient_Workflow ddClient_workflow;

    @Autowired
    private ZT_PNImpl ZT_PNImpl;


    //本地服务器密码：123456
//    private static final String url = "jdbc:mysql://47.97.181.40:3306/paineng"; // 替换为你的数据库URL
//    /// private static final String url = "jdbc:mysql://58.247.23.192:3306/paineng";
//
//    private static final String username = "root"; // 替换为你的数据库用户名
//    private static final String password = "cp-root@2022++"; // 替换为你的数据库密码
    private static final String url = "jdbc:mysql://172.20.20.41:3308/yida"; // 替换为你的数据库URL
    /// private static final String url = "jdbc:mysql://58.247.23.192:3306/paineng";

    private static final String username = "root"; // 替换为你的数据库用户名
    private static final String password = "Zeta@2024@#"; // 替换为你的数据库密码


    //
    @Override
    public void ads_hr_work_hours_sub_o(List<Map<Object, Object>> mso) {
        if (mso != null && mso.size() > 0) {
            int i = 1;
            for (Map<Object, Object> map : mso) {
                try {
                    log.info("ads_hr_work_hours_sub_o表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                    System.out.println("ads_hr_work_hours_sub_o表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                    Map entry = map;//数据写入宜搭
                    String UID = entry.get("employeeid").toString() + entry.get("s_date");//uid
                    String company_name = entry.get("company_name").toString();//所属公司
                    String formUuid = "";
                    String appType = "";
                    String systemToken = "";
                    if (company_name.equals("上海派能")) {
                        appType = "APP_U4GYY20ZKB7REZKT8586";
                        systemToken = "9Z766DC19KWMUGCK7OQ8Z8UQ30YB2VVY74PYLCI3";
                        formUuid = "FORM-292242BD1A5F4B2E98492012BC933B21YMCP";
                    }
                    if (company_name.equals("扬州派能")) {
                        appType = "APP_LECHEG4IXU554WD3BOUB";
                        systemToken = "5H9662C1TMHPRLFDANK0ZCOVUF4I3WOLUMB2MG";
                        formUuid = "FORM-D25D47ED37B04AEBBE9E0D8C25E3E26E2C2Y";
                    }
                    if (company_name.equals("安徽派能")) {
                        appType = "APP_IEZRE28YCR3DE8EFOMG3";
                        systemToken = "F2766O915RHP3GY2E4K3M9PF82S92HGY8RC2M122";
                        formUuid = "FORM-A8688536A34849A7A31A745E6E05719EXZUU";

                    }
                    if (!UID.equals("")) {
                        // 构建查询参数
                        cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
                        searchCondition.put("textField_m3wge5hw", UID);
                        if (true) {
                            Map hashMap = new HashMap();
                            hashMap.put("textField_m3wge5hw", UID);//UID
                            hashMap.put("dateField_m3whj3z5", dateString_NYR(entry.get("s_date").toString()));//时间
                            hashMap.put("dateField_m0yq8grr", dateString_NYR(entry.get("s_date").toString()));//选择周期/月
                            hashMap.put("textField_m3whj3z6", entry.get("company_name").toString());//所属公司
                            hashMap.put("textField_m340t8ca", entry.get("truename").toString());//员工姓名
                            hashMap.put("textField_m2ws1hng", entry.get("employeeid").toString());//员工工号
                            hashMap.put("numberField_m2ws1hnh", entry.get("work_hours").toString());//员工工时
                            hashMap.put("textField_m340t8cd", entry.get("dorm").toString());//是否住宿
                            hashMap.put("dateField_m3gqgig3", dateString_NYR(entry.get("s_date").toString()));//年
                            ydClient.operateData(YDParam.builder()
                                    .appType(appType)
                                    .systemToken(systemToken)
                                    .formUuid(formUuid)
                                    .searchCondition(JSON.toJSONString(searchCondition))
                                    .formDataJson(JSON.toJSONString(hashMap))
                                    .build(), YDConf.FORM_OPERATION.upsert_v2);

                        }
                    }


                } catch (Exception a) {
                    log.info(a.toString());
                    System.out.println(a.toString());
                }
                i++;//累计个数
            }


        }

    }

    public void ads_hr_work_hours_sum_o(List<Map<Object, Object>> mso) {
        if (mso != null && mso.size() > 0) {
            int i = 1;
            for (Map<Object, Object> map : mso) {
                try {
                    log.info("ads_hr_work_hours_sum_o表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                    System.out.println("ads_hr_work_hours_sum_o表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                    Map entry = map;//数据写入宜搭
                    String UID = entry.get("employeeid").toString() + entry.get("year_month");//uid
                    String company_name = entry.get("company_name").toString();//所属公司
                    if (company_name.equals("上海派能") || company_name.equals("扬州派能") || company_name.equals("安徽派能")) {
                        String formUuid = "";
                        String appType = "";
                        String systemToken = "";
                        if (company_name.equals("上海派能")) {
                            appType = "APP_U4GYY20ZKB7REZKT8586";
                            systemToken = "9Z766DC19KWMUGCK7OQ8Z8UQ30YB2VVY74PYLCI3";
                            formUuid = "FORM-8933E97A718F4A44A295BCB97CF65F6BNGUM";
                        }
                        if (company_name.equals("扬州派能")) {
                            appType = "APP_LECHEG4IXU554WD3BOUB";
                            systemToken = "5H9662C1TMHPRLFDANK0ZCOVUF4I3WOLUMB2MG";
                            formUuid = "FORM-E796F3E3BCAF40A8AF2CB4AAF42C836FQFTA";
                        }
                        if (company_name.equals("安徽派能")) {
                            appType = "APP_IEZRE28YCR3DE8EFOMG3";
                            systemToken = "F2766O915RHP3GY2E4K3M9PF82S92HGY8RC2M122";
                            formUuid = "FORM-3E8CE9B548A44DA698F1E5EBCD61CC13SVJ7";

                        }
                        if (!UID.equals("")) {
                            // 构建查询参数
//                        cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
//                        searchCondition.put("textField_m3wge5hw", UID);
                            List<Map> searchCondition = Arrays.asList(YDConf.searchCondition_TextFiled("textField_m3wge5hw", UID, "eq"));
                            if (true) {
                                Map hashMap = new HashMap();
                                hashMap.put("textField_m3wge5hw", UID);//UID
                                //  hashMap.put("dateField_m3whj3z5", dateString_NYR(entry.get("s_date").toString()));//时间
                                hashMap.put("dateField_m0yq8grr", dateString_NY(entry.get("year_month").toString()));//选择周期/月
                                hashMap.put("selectField_m2ws1hnj", entry.get("company_name").toString());//所属公司
                                hashMap.put("textField_m340t8ca", entry.get("truename").toString());//员工姓名
                                hashMap.put("textField_m2ws1hng", entry.get("employeeid").toString());//员工工号
                                hashMap.put("numberField_m2ws1hnh", entry.get("month_work_hours").toString());//员工工时
                                hashMap.put("textField_m340t8cd", entry.get("dorm").toString());//是否住宿
                                hashMap.put("dateField_m3gqgig3", dateString_NY(entry.get("year_month").toString()));//年
                                hashMap.put("textField_m4ay8d3s", entry.get("year_month").toString().substring(0, 4));//年
                                ydClient.operateData(YDParam.builder()
                                        .appType(appType)
                                        .systemToken(systemToken)
                                        .formUuid(formUuid)
                                        .noExecuteExpression(false)
                                        .searchCondition(JSON.toJSONString(searchCondition))
                                        .formDataJson(JSON.toJSONString(hashMap))
                                        .build(), YDConf.FORM_OPERATION.upsert);

                            }
                        }
                    }


                } catch (Exception a) {
                    log.info(a.toString());
                    System.out.println(a.toString());
                }
                i++;//累计个数
            }


        }

    }

    @Override
    public void dwd_sal_ship_order_det_i(List<Map<Object, Object>> mso) {

        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {
                        array[i] = new String[]{
                                (String) entry.get("u_id").toString(), (String) longtimeToDate(stringtotime(Long.valueOf(entry.get("delivery_date").toString()))), (String) entry.get("so_no").toString(), (String) entry.get("so_type").toString(), (String) entry.get("cus_po_no").toString(), (String) entry.get("ci_no").toString(), (String) entry.get("cus_name").toString()
                                , (String) entry.get("dep_name").toString(), (String) entry.get("created_by").toString(), (String) entry.get("salesman").toString(), (String) entry.get("region").toString(), (String) entry.get("ship_status").toString()
                                , (String) entry.get("part_no").toString(), (String) entry.get("n8_no").toString(), (String) entry.get("part_name").toString(), (String) entry.get("ship_qty").toString(), (String) entry.get("ship_amt_tot").toString()
                                , (String) entry.get("final_price").toString(), (String) entry.get("fin_pri_total").toString(), (String) entry.get("currency").toString(), (String) entry.get("act_fce_rate").toString(), (String) entry.get("storage_location").toString(), (String) entry.get("ship_no").toString(), (String) entry.get("ship_plan_no").toString(), (String) entry.get("ope_org_name").toString(), (String) entry.get("ship_org_name").toString(), (String) entry.get("overseas").toString()
                                , (String) entry.get("term").toString(), (String) entry.get("payment_terms").toString(), (String) entry.get("capacity").toString(), (String) entry.get("total_capacity").toString(), (String) entry.get("region").toString()
                                , String.valueOf(Double.valueOf(entry.get("act_fce_rate").toString()) * Double.valueOf(entry.get("ship_amt_tot").toString())), (String) longtimeToDate(stringtotime(Long.valueOf(entry.get("delivery_date").toString()))), (String) longtimeToDate(stringtotime(Long.valueOf(entry.get("delivery_date").toString()))), (String) longtimeToDate(stringtotime(Long.valueOf(entry.get("delivery_date").toString()))), entry.get("cus_name").toString().contains("派能") ? "是" : "否"
                        };
                        i++;
                    }
                }
                if (i > 0) {
                    String sql = "INSERT INTO dwd_sal_ship_order_det_i (UID, delivery_date, so_no, so_type, cus_po_no, ci_no, cus_name, dep_name, created_by, salesman, region, ship_status, part_no, n8_no, part_name, ship_qty, ship_amt_tot, final_price, fin_pri_total, currency, act_fce_rate, storage_location, ship_no, ship_plan_no, ope_org_name, ship_org_name, overseas, term, payment_terms, capacity, total_capacity, region_region_, act_fce_rateship_amt_tot, delivery_date_nian, delivery_date_ji, delivery_date_yue, cus_name_cus_name, creation_time)" +
                            "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?) ";

                    Connection connection = null;
                    PreparedStatement preparedStatement = null;
                    try {
                        connection = getConnection();
                        preparedStatement = connection.prepareStatement(sql);
                        connection.setAutoCommit(false);
                        int nums = 0;
                        for (String[] row : array) {
                            if (nums < i) {
                                LocalDateTime now = LocalDateTime.now();
                                // 定义日期时间格式化器
                                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                // 格式化日期时间
                                String formattedDateTime = now.format(formatter);
                                preparedStatement.setString(1, row[0]);
                                preparedStatement.setString(2, row[1]);
                                preparedStatement.setString(3, row[2]);
                                preparedStatement.setString(4, row[3]);
                                preparedStatement.setString(5, row[4]);
                                preparedStatement.setString(6, row[5]);
                                preparedStatement.setString(7, row[6]);
                                preparedStatement.setString(8, row[7]);
                                preparedStatement.setString(9, row[8]);
                                preparedStatement.setString(10, row[9]);
                                preparedStatement.setString(11, row[10]);
                                preparedStatement.setString(12, row[11]);
                                preparedStatement.setString(13, row[12]);
                                preparedStatement.setString(14, row[13]);
                                preparedStatement.setString(15, row[14]);
                                preparedStatement.setString(16, row[15]);
                                preparedStatement.setString(17, row[16]);
                                preparedStatement.setString(18, row[17]);
                                preparedStatement.setString(19, row[18]);
                                preparedStatement.setString(20, row[19]);
                                preparedStatement.setString(21, row[20]);
                                preparedStatement.setString(22, row[21]);
                                preparedStatement.setString(23, row[22]);
                                preparedStatement.setString(24, row[23]);
                                preparedStatement.setString(25, row[24]);
                                preparedStatement.setString(26, row[25]);
                                preparedStatement.setString(27, row[26]);
                                preparedStatement.setString(28, row[27]);
                                preparedStatement.setString(29, row[28]);
                                preparedStatement.setString(30, row[29]);
                                preparedStatement.setString(31, row[30]);
                                preparedStatement.setString(32, row[31]);
                                preparedStatement.setString(33, row[32]);
                                preparedStatement.setString(34, row[33]);
                                preparedStatement.setString(35, row[34]);
                                preparedStatement.setString(36, row[35]);
                                preparedStatement.setString(37, row[36]);
                                preparedStatement.setString(38, formattedDateTime);
                                preparedStatement.addBatch();
                            }
                            nums++;
                        }
                        // Execute batch
                        int[] counts = preparedStatement.executeBatch();
                        connection.commit();
                        System.out.println("dwd_sal_ship_order_det_i 本次同步完成:Inserted " + counts.length + " rows.");
                    } catch (SQLException e) {
                        e.printStackTrace();
                    } finally {
                        // 确保资源被关闭
                        try {
                            if (preparedStatement != null) preparedStatement.close();
                            if (connection != null) connection.close();
                        } catch (SQLException ex) {
                            ex.printStackTrace();
                        }
                    }
                }


            }
        }

    }

    @Override
    public void ads_fin_gross_profit_margin_i(List<Map<Object, Object>> mso) {
        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {


                        array[i] = new String[]{(String) entry.get("uid").toString(), (String) entry.get("org_name").toString(), (String) entry.get("displayname").toString(), (String) entry.get("so_no").toString(), (String) entry.get("type_nm").toString(), (String) entry.get("department_name").toString()
                                , (String) entry.get("market_classify").toString(), (String) entry.get("product_classify").toString(), (String) entry.get("paycust_name").toString(), (String) entry.get("kpi_cust_name").toString(), (String) entry.get("region").toString(), (String) entry.get("country").toString(),
                                (String) entry.get("item_itemcode").toString(), (String) entry.get("unit_qty").toString(), (String) entry.get("item_itemname").toString(), (String) entry.get("tot_unit_qty").toString(), (String) entry.get("qty").toString(), (String) entry.get("arbillrcline_puamount").toString(), (String) entry.get("univalence").toString()
                                , (String) entry.get("unit_cost").toString(), (String) entry.get("bc_name").toString(), (String) entry.get("revenuemoney_fcmoney_oc").toString(), (String) entry.get("revenuemoney_fcmoney").toString(), (String) entry.get("zz_cost").toString(), (String) entry.get("freight").toString()
                                , (String) entry.get("stock_payment").toString(), (String) entry.get("tax").toString(), (String) entry.get("salegrossprofit").toString(), (String) entry.get("gro_pro_rate").toString(), (String) entry.get("seq_num").toString(), (String) entry.get("parms").toString(), String.valueOf(i)
                        };
                        i++;
                    }
                }
                if (i > 0) {


                    String sql = "INSERT INTO ads_fin_gross_profit_margin_i (UID, org_name, displayname, so_no, type_nm, department_name, market_classify, product_classify, paycust_name, kpi_cust_name, region, country, item_itemcode, unit_qty, item_itemname, tot_unit_qty, qty, arbillrcline_puamount, univalence, unit_cost, bc_name, revenuemoney_fcmoney_oc, revenuemoney_fcmoney, zz_cost, freight, stock_payment, tax, salegrossprofit, gro_pro_rate, seq_num, parms, inder_size, creation_time)" +
                            "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                    Connection connection = null;
                    PreparedStatement preparedStatement = null;
                    try {
                        connection = getConnection();
                        preparedStatement = connection.prepareStatement(sql);
                        connection.setAutoCommit(false);
                        int nums = 0;
                        for (String[] row : array) {
                            if (nums < i) {
                                LocalDateTime now = LocalDateTime.now();
                                // 定义日期时间格式化器
                                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                // 格式化日期时间
                                String formattedDateTime = now.format(formatter);
                                preparedStatement.setString(1, row[0]);
                                preparedStatement.setString(2, row[1]);
                                preparedStatement.setString(3, row[2]);
                                preparedStatement.setString(4, row[3]);
                                preparedStatement.setString(5, row[4]);
                                preparedStatement.setString(6, row[5]);
                                preparedStatement.setString(7, row[6]);
                                preparedStatement.setString(8, row[7]);
                                preparedStatement.setString(9, row[8]);
                                preparedStatement.setString(10, row[9]);
                                preparedStatement.setString(11, row[10]);
                                preparedStatement.setString(12, row[11]);
                                preparedStatement.setString(13, row[12]);
                                preparedStatement.setString(14, row[13]);
                                preparedStatement.setString(15, row[14]);
                                preparedStatement.setString(16, row[15]);
                                preparedStatement.setString(17, row[16]);
                                preparedStatement.setString(18, row[17]);
                                preparedStatement.setString(19, row[18]);
                                preparedStatement.setString(20, row[19]);
                                preparedStatement.setString(21, row[20]);
                                preparedStatement.setString(22, row[21]);
                                preparedStatement.setString(23, row[22]);
                                preparedStatement.setString(24, row[23]);
                                preparedStatement.setString(25, row[24]);
                                preparedStatement.setString(26, row[25]);
                                preparedStatement.setString(27, row[26]);
                                preparedStatement.setString(28, row[27]);
                                preparedStatement.setString(29, row[28]);
                                preparedStatement.setString(30, row[29]);
                                preparedStatement.setString(31, row[30]);
                                preparedStatement.setString(32, row[31]);
                                preparedStatement.setString(33, formattedDateTime);
                                preparedStatement.addBatch();
                            }
                            nums++;
                        }
                        // Execute batch
                        int[] counts = preparedStatement.executeBatch();
                        connection.commit();
                        System.out.println("ads_fin_gross_profit_margin_i 本次同步完成:Inserted " + counts.length + " rows.");
                    } catch (SQLException e) {
                        e.printStackTrace();
                    } finally {
                        // 确保资源被关闭
                        try {
                            if (preparedStatement != null) preparedStatement.close();
                            if (connection != null) connection.close();
                        } catch (SQLException ex) {
                            ex.printStackTrace();
                        }
                    }
                }


            }
        }
        if (false) {
            if (mso != null && mso.size() > 0) {
                int i = 1;
                for (Map<Object, Object> map : mso) {
                    try {
                        log.info("ads_fin_gross_profit_margin_i表第:" + i + "/" + mso.size() + "正在写入到数据库！");
                        System.out.println("ads_fin_gross_profit_margin_i表第:" + i + "/" + mso.size() + " 正在写入到数据库！");
                        Map entry = map;//数据写入宜搭
                        String UID = entry.get("uid").toString();
                        if (!UID.equals("")) {
                            if (true) {


                                String sql = "INSERT INTO ads_fin_gross_profit_margin_i (UID, org_name, displayname, so_no, type_nm, department_name, market_classify, product_classify, paycust_name, kpi_cust_name, region, country, item_itemcode, unit_qty, item_itemname, tot_unit_qty, qty, arbillrcline_puamount, univalence, unit_cost, bc_name, revenuemoney_fcmoney_oc, revenuemoney_fcmoney, zz_cost, freight, stock_payment, tax, salegrossprofit, gro_pro_rate, seq_num, parms, inder_size)" +
                                        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

//                                String sql = "INSERT INTO ads_fin_gross_profit_margin_i (UID, org_name, displayname, so_no, type_nm, department_name, market_classify, product_classify, paycust_name, kpi_cust_name, region, country, item_itemcode, unit_qty, item_itemname, tot_unit_qty, qty, arbillrcline_puamount, univalence, unit_cost, bc_name, revenuemoney_fcmoney_oc, revenuemoney_fcmoney, zz_cost, freight, stock_payment, tax, salegrossprofit, gro_pro_rate, seq_num)" +
//                                        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)" +
//                                        "ON DUPLICATE KEY UPDATE org_name = VALUES(org_name),displayname = VALUES(displayname),so_no = VALUES(so_no),type_nm = VALUES(type_nm),department_name = VALUES(department_name),market_classify = VALUES(market_classify),product_classify = VALUES(product_classify) " +
//                                        ",paycust_name = VALUES(paycust_name),kpi_cust_name = VALUES(kpi_cust_name),region = VALUES(region),country = VALUES(country),item_itemcode = VALUES(item_itemcode),unit_qty = VALUES(unit_qty),item_itemname = VALUES(item_itemname),tot_unit_qty = VALUES(tot_unit_qty)" +
//                                        ",qty = VALUES(qty),arbillrcline_puamount = VALUES(arbillrcline_puamount),univalence = VALUES(univalence),unit_cost = VALUES(unit_cost),bc_name = VALUES(bc_name),revenuemoney_fcmoney_oc = VALUES(revenuemoney_fcmoney_oc),revenuemoney_fcmoney = VALUES(revenuemoney_fcmoney)" +
//                                        ",zz_cost = VALUES(zz_cost),freight = VALUES(freight),stock_payment = VALUES(stock_payment),tax = VALUES(tax),salegrossprofit = VALUES(salegrossprofit),gro_pro_rate = VALUES(gro_pro_rate),seq_num = VALUES(seq_num)"; // 替换为你的表和列名
                                Connection connection = null;
                                PreparedStatement preparedStatement = null;
                                try {

                                    connection = getConnection();
                                    preparedStatement = connection.prepareStatement(sql);
                                    preparedStatement.setString(1, (String) entry.get("uid").toString());
                                    preparedStatement.setString(2, (String) entry.get("org_name").toString());
                                    preparedStatement.setString(3, (String) entry.get("displayname").toString());
                                    preparedStatement.setString(4, (String) entry.get("so_no").toString());
                                    preparedStatement.setString(5, (String) entry.get("type_nm").toString());
                                    preparedStatement.setString(6, (String) entry.get("department_name").toString());
                                    preparedStatement.setString(7, (String) entry.get("market_classify").toString());
                                    preparedStatement.setString(8, (String) entry.get("product_classify").toString());
                                    preparedStatement.setString(9, (String) entry.get("paycust_name").toString());
                                    preparedStatement.setString(10, (String) entry.get("kpi_cust_name").toString());
                                    preparedStatement.setString(11, (String) entry.get("region").toString());
                                    preparedStatement.setString(12, (String) entry.get("country").toString());
                                    preparedStatement.setString(13, (String) entry.get("item_itemcode").toString());
                                    preparedStatement.setString(14, (String) entry.get("unit_qty").toString());
                                    preparedStatement.setString(15, (String) entry.get("item_itemname").toString());
                                    preparedStatement.setString(16, (String) entry.get("tot_unit_qty").toString());
                                    preparedStatement.setString(17, (String) entry.get("qty").toString());
                                    preparedStatement.setString(18, (String) entry.get("arbillrcline_puamount").toString());
                                    preparedStatement.setString(19, (String) entry.get("univalence").toString());
                                    preparedStatement.setString(20, (String) entry.get("unit_cost").toString());
                                    preparedStatement.setString(21, (String) entry.get("bc_name").toString());
                                    preparedStatement.setString(22, (String) entry.get("revenuemoney_fcmoney_oc").toString());
                                    preparedStatement.setString(23, (String) entry.get("revenuemoney_fcmoney").toString());
                                    preparedStatement.setString(24, (String) entry.get("zz_cost").toString());
                                    preparedStatement.setString(25, (String) entry.get("freight").toString());
                                    preparedStatement.setString(26, (String) entry.get("stock_payment").toString());
                                    preparedStatement.setString(27, (String) entry.get("tax").toString());
                                    preparedStatement.setString(28, (String) entry.get("salegrossprofit").toString());
                                    preparedStatement.setString(29, (String) entry.get("gro_pro_rate").toString());
                                    preparedStatement.setString(30, (String) entry.get("seq_num").toString());
                                    preparedStatement.setString(31, (String) entry.get("parms").toString());
                                    preparedStatement.setString(32, String.valueOf(i));


                                    int rowsAffected = preparedStatement.executeUpdate();
                                    if (rowsAffected > 0) {
                                        System.out.println("数据插入成功！");
                                    }
                                } catch (SQLException e) {
                                    e.printStackTrace();
                                } finally {
                                    // 确保资源被关闭
                                    try {
                                        if (preparedStatement != null) preparedStatement.close();
                                        if (connection != null) connection.close();
                                    } catch (SQLException ex) {
                                        ex.printStackTrace();
                                    }
                                }
                            }
//                            if (true) {
//                                Map hashMap = new HashMap();
//                                hashMap.put("textField_m3483xa2", entry.get("org_name").toString());//所属公司
//                                hashMap.put("dateField_m3483xa9", dateString_NY(entry.get("displayname").toString()));//入账日期
//                                hashMap.put("textField_m3483xa4", entry.get("so_no").toString());//销售订单号
//                                hashMap.put("textField_m3483xa6", entry.get("type_nm").toString());//类型
//                                hashMap.put("textField_m3483xa8", entry.get("department_name").toString());//部门
//                                hashMap.put("textField_m3483xab", entry.get("market_classify").toString());//市场分类
//                                hashMap.put("textField_m3483xad", entry.get("product_classify").toString());//产品分类
//                                hashMap.put("textField_m3483xaf", entry.get("paycust_name").toString());//客户名称
//                                hashMap.put("textField_m3483xah", entry.get("kpi_cust_name").toString());//KGI客户
//                                hashMap.put("textField_m3483xaj", entry.get("region").toString());//洲
//                                hashMap.put("textField_m3483xal", entry.get("country").toString());//国家
//                                hashMap.put("textField_m3483xan", entry.get("item_itemcode").toString());//产品整理
//                                hashMap.put("textField_m3483xap", entry.get("item_itemname").toString());//产品
//                                hashMap.put("numberField_m3s7e4i4", entry.get("unit_qty").toString());//单位数量(wh)
//                                hashMap.put("numberField_m3483xaw", entry.get("tot_unit_qty").toString());//合计数量(wh)
//                                hashMap.put("numberField_m3483xay", entry.get("qty").toString());//数量(ah)
//                                hashMap.put("numberField_m3483xb0", entry.get("arbillrcline_puamount").toString());//数量（台/套）
//                                hashMap.put("numberField_m3483xb2", entry.get("univalence").toString());//销售单价
//                                hashMap.put("numberField_m3483xb4", entry.get("unit_cost").toString());//单位成本
//                                hashMap.put("textField_m3483xat", entry.get("bc_name").toString());//币种
//                                hashMap.put("numberField_m3483xb6", entry.get("revenuemoney_fcmoney_oc").toString());//销售收入（原币）'
//                                hashMap.put("numberField_m3483xb8", entry.get("revenuemoney_fcmoney").toString());//销售收入
//                                hashMap.put("numberField_m3483xba", entry.get("zz_cost").toString());//账载成本
//                                hashMap.put("numberField_m3483xbc", entry.get("freight").toString());//运费
//                                hashMap.put("textField_m3483xav", entry.get("stock_payment").toString());//股份支付
//                                hashMap.put("numberField_m3483xbe", entry.get("tax").toString());//税额
//                                hashMap.put("numberField_m3483xbg", entry.get("salegrossprofit").toString());//销售毛利
//                                hashMap.put("numberField_m3483xbi", entry.get("gro_pro_rate").toString());//毛利率
//                                hashMap.put("numberField_m3483xbk", entry.get("seq_num").toString());//序号
//                                hashMap.put("textField_m3sbsznw", UID);//uid
//                                cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
//                                searchCondition.put("textField_m3sbsznw", UID);
//                                ydClient.operateData(YDParam.builder()
//                                        .appType("APP_U3W7R66HBXPW5T4LETZ7")
//                                        .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
//                                        .formUuid("FORM-7EA2ED0A232248118922919C1E2170011S9L")
//                                        .searchCondition(JSON.toJSONString(searchCondition))
//                                        .formDataJson(JSON.toJSONString(hashMap))
//                                        .build(), YDConf.FORM_OPERATION.upsert);
//                            }

                        }


                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }
                    i++;//累计个数
                }


            }
        }
        if (false) {
            if (mso != null && mso.size() > 0) {
                int i = 1;
                for (Map<Object, Object> map : mso) {
                    try {
                        log.info("ads_fin_gross_profit_margin_i表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                        System.out.println("ads_fin_gross_profit_margin_i表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                        Map entry = map;//数据写入宜搭
                        String UID = entry.get("uid").toString();
                        if (!UID.equals("")) {
                            // 构建查询参数
                            cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
                            searchCondition.put("textField_m3sbsznw", UID);
                            List<Map> list = (List<Map>) ydClient.queryData(
                                    YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formUuid("FORM-7EA2ED0A232248118922919C1E2170011S9L")
                                            .searchCondition(JSON.toJSONString(searchCondition))
                                            .build(),
                                    YDConf.FORM_QUERY.retrieve_list).getData();
                            if (list.size() > 0) {//判断UID有数据，就做更新
                                if (true) {
                                    String formInstanceId = list.get(0).get("formInstanceId").toString();
                                    String ZD = "textField_m3483xa2, dateField_m3483xa9, textField_m3483xa4, textField_m3483xa6, textField_m3483xa8, textField_m3483xab, textField_m3483xad, textField_m3483xaf, textField_m3483xah, textField_m3483xaj, textField_m3483xal, textField_m3483xan, textField_m3483xap, numberField_m3s7e4i4, ";
                                    ZD += "numberField_m3483xaw, numberField_m3483xay, numberField_m3483xb0, numberField_m3483xb2, numberField_m3483xb4, textField_m3483xat, numberField_m3483xb6, numberField_m3483xb8, numberField_m3483xba, numberField_m3483xbc, textField_m3483xav, ";
                                    ZD += "numberField_m3483xbe, numberField_m3483xbg, numberField_m3483xbi, numberField_m3483xbk, textField_m3sbsznw";


                                    ydClient.operateData(YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formInstanceId(String.valueOf(formInstanceId))
                                            .updateFormDataJson(JSON.toJSONString(UtilMap.map(ZD, entry.get("org_name").toString(), dateString_NY(entry.get("displayname").toString()), entry.get("so_no").toString(), entry.get("type_nm").toString(), entry.get("department_name").toString(), entry.get("market_classify").toString(), entry.get("product_classify").toString()
                                                    , entry.get("paycust_name").toString(), entry.get("kpi_cust_name").toString(), entry.get("region").toString(), entry.get("country").toString(), entry.get("item_itemcode").toString(), entry.get("item_itemname").toString(), entry.get("unit_qty").toString()
                                                    , entry.get("tot_unit_qty").toString(), entry.get("qty").toString(), entry.get("arbillrcline_puamount").toString(), entry.get("univalence").toString(), entry.get("unit_cost").toString(), entry.get("bc_name").toString(), entry.get("revenuemoney_fcmoney_oc").toString()
                                                    , entry.get("revenuemoney_fcmoney").toString(), entry.get("zz_cost").toString(), entry.get("freight").toString(), entry.get("stock_payment").toString(), entry.get("tax").toString(), entry.get("salegrossprofit").toString(), entry.get("gro_pro_rate").toString(), entry.get("seq_num").toString(), UID)))
                                            .build(), YDConf.FORM_OPERATION.update);
                                    ydClient.operateData(YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formInstanceId(String.valueOf(formInstanceId))
                                            .updateFormDataJson(JSON.toJSONString(UtilMap.map(ZD, entry.get("org_name").toString(), dateString_NY(entry.get("displayname").toString()), entry.get("so_no").toString(), entry.get("type_nm").toString(), entry.get("department_name").toString(), entry.get("market_classify").toString(), entry.get("product_classify").toString()
                                                    , entry.get("paycust_name").toString(), entry.get("kpi_cust_name").toString(), entry.get("region").toString(), entry.get("country").toString(), entry.get("item_itemcode").toString(), entry.get("item_itemname").toString(), entry.get("unit_qty").toString()
                                                    , entry.get("tot_unit_qty").toString(), entry.get("qty").toString(), entry.get("arbillrcline_puamount").toString(), entry.get("univalence").toString(), entry.get("unit_cost").toString(), entry.get("bc_name").toString(), entry.get("revenuemoney_fcmoney_oc").toString()
                                                    , entry.get("revenuemoney_fcmoney").toString(), entry.get("zz_cost").toString(), entry.get("freight").toString(), entry.get("stock_payment").toString(), entry.get("tax").toString(), entry.get("salegrossprofit").toString(), entry.get("gro_pro_rate").toString(), entry.get("seq_num").toString(), UID)))
                                            .build(), YDConf.FORM_OPERATION.update);

                                }
                            } else {// //判断UID无数据，新增
                                if (true) {
                                    Map hashMap = new HashMap();
                                    hashMap.put("textField_m3483xa2", entry.get("org_name").toString());//所属公司
                                    hashMap.put("dateField_m3483xa9", dateString_NY(entry.get("displayname").toString()));//入账日期
                                    hashMap.put("textField_m3483xa4", entry.get("so_no").toString());//销售订单号
                                    hashMap.put("textField_m3483xa6", entry.get("type_nm").toString());//类型
                                    hashMap.put("textField_m3483xa8", entry.get("department_name").toString());//部门
                                    hashMap.put("textField_m3483xab", entry.get("market_classify").toString());//市场分类
                                    hashMap.put("textField_m3483xad", entry.get("product_classify").toString());//产品分类
                                    hashMap.put("textField_m3483xaf", entry.get("paycust_name").toString());//客户名称
                                    hashMap.put("textField_m3483xah", entry.get("kpi_cust_name").toString());//KGI客户
                                    hashMap.put("textField_m3483xaj", entry.get("region").toString());//洲
                                    hashMap.put("textField_m3483xal", entry.get("country").toString());//国家
                                    hashMap.put("textField_m3483xan", entry.get("item_itemcode").toString());//产品整理
                                    hashMap.put("textField_m3483xap", entry.get("item_itemname").toString());//产品
                                    hashMap.put("numberField_m3s7e4i4", entry.get("unit_qty").toString());//单位数量(wh)
                                    hashMap.put("numberField_m3483xaw", entry.get("tot_unit_qty").toString());//合计数量(wh)
                                    hashMap.put("numberField_m3483xay", entry.get("qty").toString());//数量(ah)
                                    hashMap.put("numberField_m3483xb0", entry.get("arbillrcline_puamount").toString());//数量（台/套）
                                    hashMap.put("numberField_m3483xb2", entry.get("univalence").toString());//销售单价
                                    hashMap.put("numberField_m3483xb4", entry.get("unit_cost").toString());//单位成本
                                    hashMap.put("textField_m3483xat", entry.get("bc_name").toString());//币种
                                    hashMap.put("numberField_m3483xb6", entry.get("revenuemoney_fcmoney_oc").toString());//销售收入（原币）'
                                    hashMap.put("numberField_m3483xb8", entry.get("revenuemoney_fcmoney").toString());//销售收入
                                    hashMap.put("numberField_m3483xba", entry.get("zz_cost").toString());//账载成本
                                    hashMap.put("numberField_m3483xbc", entry.get("freight").toString());//运费
                                    hashMap.put("textField_m3483xav", entry.get("stock_payment").toString());//股份支付
                                    hashMap.put("numberField_m3483xbe", entry.get("tax").toString());//税额
                                    hashMap.put("numberField_m3483xbg", entry.get("salegrossprofit").toString());//销售毛利
                                    hashMap.put("numberField_m3483xbi", entry.get("gro_pro_rate").toString());//毛利率
                                    hashMap.put("numberField_m3483xbk", entry.get("seq_num").toString());//序号
                                    hashMap.put("textField_m3sbsznw", UID);//uid
                                    ydClient.operateData(YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formUuid("FORM-7EA2ED0A232248118922919C1E2170011S9L")
                                            .formDataJson(JSON.toJSONString(hashMap))
                                            .build(), YDConf.FORM_OPERATION.create);

                                }
                            }
                        }


                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }
                    i++;//累计个数
                }


            }
        }
    }

    @Override
    public void ads_fina_gen_accoutbook_detail_i(List<Map<Object, Object>> mso) {

        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 1;
                for (Map<Object, Object> map : mso) {
                    try {
                        log.info("ads_fina_gen_accoutbook_detail_i表第:" + i + "/" + mso.size() + " 正在同步到库！");
                        System.out.println("ads_fina_gen_accoutbook_detail_i表第:" + i + "/" + mso.size() + " 正在同步到库！");
                        Map entry = map;//数据写入宜搭
                        String UID = entry.get("uid").toString();
                        String pd = entry.get("year_detail").toString() + entry.get("month_detail").toString() + entry.get("account_code1").toString() + entry.get("account_name1").toString() + entry.get("currencycode").toString() + entry.get("currencyname").toString() + entry.get("last_depart").toString() + entry.get("subject_code").toString() + entry.get("leaf_node_name").toString() + entry.get("abstracts").toString() + entry.get("createdate").toString() + entry.get("couchercategoryname").toString() + entry.get("vouchercode").toString() + entry.get("unitprice").toString() + entry.get("entereddr").toString() + entry.get("accounteddr").toString() + entry.get("sob_name").toString();
                        String enteredcr = entry.get("enteredcr").toString();
                        String accountedcr = entry.get("accountedcr").toString();
                      //  if (!UID.equals("") && enteredcr.equals("0.0") && accountedcr.equals("0.0") && !portal_PNPD.containsKey(pd)) { //与2025年0211改成不需要判断重复
                        if (true) {
                            if (true) {
                                portal_PNPD.put(pd, pd);
                                String sql = "INSERT INTO ads_fina_gen_accoutbook_detail_i (UID, year_detail, month_detail, day_detail, account_code, account_name, naturalaccount, account_lv, account_code1, account_code2, account_code3, account_code4, account_name1, account_name2, account_name3, account_name4, currencycode, currencyname, currencysymbol, last_depart, subject_code, leaf_node_name, abstracts, createdate, vouchercategorycode, couchercategoryname, vouchercode, unitprice, entereddr, accounteddr, enteredcr, accountedcr, sob_code, sob_name, interface_time, creation_time)" +
                                        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?)";
                                 Connection connection = null;
                                PreparedStatement preparedStatement = null;
                                try {
                                    LocalDateTime now = LocalDateTime.now();
                                    // 定义日期时间格式化器
                                    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                    // 格式化日期时间
                                    String formattedDateTime = now.format(formatter);

                                    connection = getConnection();
                                    preparedStatement = connection.prepareStatement(sql);
                                    preparedStatement.setString(1, UID);
                                    preparedStatement.setString(2, (String) entry.get("year_detail").toString());
                                    preparedStatement.setString(3, (String) entry.get("month_detail").toString());
                                    preparedStatement.setString(4, (String) entry.get("day_detail").toString());
                                    preparedStatement.setString(5, (String) entry.get("account_code").toString());
                                    preparedStatement.setString(6, (String) entry.get("account_name").toString());
                                    preparedStatement.setString(7, (String) entry.get("naturalaccount").toString());
                                    preparedStatement.setString(8, (String) entry.get("account_lv").toString());
                                    preparedStatement.setString(9, (String) entry.get("account_code1").toString());
                                    preparedStatement.setString(10, (String) entry.get("account_code2").toString());
                                    preparedStatement.setString(11, (String) entry.get("account_code3").toString());
                                    preparedStatement.setString(12, (String) entry.get("account_code4").toString());
                                    preparedStatement.setString(13, (String) entry.get("account_name1").toString());
                                    preparedStatement.setString(14, (String) entry.get("account_name2").toString());
                                    preparedStatement.setString(15, (String) entry.get("account_name3").toString());
                                    preparedStatement.setString(16, (String) entry.get("account_name4").toString());
                                    preparedStatement.setString(17, (String) entry.get("currencycode").toString());
                                    preparedStatement.setString(18, (String) entry.get("currencyname").toString());
                                    preparedStatement.setString(19, (String) entry.get("currencysymbol").toString());
                                    preparedStatement.setString(20, (String) entry.get("last_depart").toString());
                                    preparedStatement.setString(21, (String) entry.get("subject_code").toString());
                                    preparedStatement.setString(22, (String) entry.get("leaf_node_name").toString());
                                    preparedStatement.setString(23, (String) entry.get("abstracts").toString());
                                    preparedStatement.setString(24, (String) entry.get("createdate").toString());
                                    preparedStatement.setString(25, (String) entry.get("vouchercategorycode").toString());
                                    preparedStatement.setString(26, (String) entry.get("couchercategoryname").toString());
                                    preparedStatement.setString(27, (String) entry.get("vouchercode").toString());
                                    preparedStatement.setString(28, (String) entry.get("unitprice").toString());
                                    preparedStatement.setString(29, (String) entry.get("entereddr").toString());
                                    preparedStatement.setString(30, (String) entry.get("accounteddr").toString());
                                    preparedStatement.setString(31, (String) entry.get("enteredcr").toString());
                                    preparedStatement.setString(32, (String) entry.get("accountedcr").toString());
                                    preparedStatement.setString(33, (String) entry.get("sob_code").toString());
                                    preparedStatement.setString(34, (String) entry.get("sob_name").toString());
                                    preparedStatement.setString(35, (String) entry.get("interface_time").toString());
                                    preparedStatement.setString(36, formattedDateTime);
                                    int rowsAffected = preparedStatement.executeUpdate();
                                    if (rowsAffected > 0) {
                                        System.out.println("数据插入成功！");
                                    }
                                } catch (SQLException e) {
                                    e.printStackTrace();
                                } finally {
                                    // 确保资源被关闭
                                    try {
                                        if (preparedStatement != null) preparedStatement.close();
                                        if (connection != null) connection.close();
                                    } catch (SQLException ex) {
                                        ex.printStackTrace();
                                    }
                                }
                            }

//                            if (true) {
//                                Map hashMap = new HashMap();
//                                hashMap.put("textField_m33t6vai", entry.get("serialno").toString());//行号
////                                if (!entry.get("displayname").toString().equals("")) {
////                                    hashMap.put("dateField_m33t6vas", entry.get("displayname").toString().equals("") ? null : entry.get("displayname").toString().equals(""));//时间
////                                }
//                                hashMap.put("textField_m33t6vak", entry.get("year_detail").toString());//年
//                                hashMap.put("textField_m33t6vam", entry.get("month_detail").toString());//月
//                                hashMap.put("textField_m33t6vao", entry.get("day_detail").toString());//日
//                                hashMap.put("textField_m33t6vaq", entry.get("account_code").toString());//科目编码
//                                hashMap.put("textField_m33t6vat", entry.get("account_name").toString());//科目名称
//                                hashMap.put("textField_m33t6vau", entry.get("naturalaccount").toString());//自然客户编码
//                                hashMap.put("textField_m33t6vav", entry.get("account_lv").toString());//客户级别
//                                hashMap.put("textField_m33t6vaw", entry.get("account_code1").toString());//1级科目编码
//                                hashMap.put("textField_m33t6vay", entry.get("account_code2").toString());//2级科目编码
//                                hashMap.put("textField_m33t6vb7", entry.get("account_code3").toString());//3级科目编码
//                                hashMap.put("textField_m33t6vb9", entry.get("account_code4").toString());//4级科目编码
//                                hashMap.put("textField_m33t6vax", entry.get("account_name1").toString());//1级科目名称
//                                hashMap.put("textField_m33t6vaz", entry.get("account_name2").toString());//2级科目名称
//                                hashMap.put("textField_m33t6vb6", entry.get("account_name3").toString());//3级科目名称
//                                hashMap.put("textField_m33t6vb8", entry.get("account_name4").toString());//4级科目名称
//                                hashMap.put("textField_m33t6vbb", entry.get("currencycode").toString());//币种编码
//                                hashMap.put("textField_m33t6vbc", entry.get("currencyname").toString());//币种名称
//                                hashMap.put("textField_m33t6vbd", entry.get("currencysymbol").toString());//币种单位
//                                hashMap.put("textField_m3se4z4w", entry.get("last_depart").toString());//部门末级
//                                hashMap.put("textField_m33t6vbe", entry.get("subject_code").toString());//末级科目编码
//                                hashMap.put("textField_m33t6vbf", entry.get("leaf_node_name").toString());//末级科目名称
//                                hashMap.put("textField_m33t6vbg", entry.get("abstracts").toString());//摘要
//                                hashMap.put("dateField_m33t6vbh", dateString_NYRSFM(entry.get("createdate").toString()));//制单日期
//                                hashMap.put("textField_m33t6vbi", entry.get("vouchercategorycode").toString());//凭证类型编码
//                                hashMap.put("textField_m33t6vbj", entry.get("couchercategoryname").toString());//凭证类型
//                                hashMap.put("textField_m33t6vbk", entry.get("vouchercode").toString());//凭证号
//                                hashMap.put("numberField_m33t6vbm", entry.get("unitprice").toString());//单价
//                                hashMap.put("numberField_m33t6vbn", entry.get("entereddr").toString());//借方金额（原币）
//                                hashMap.put("numberField_m33t6vbo", entry.get("accounteddr").toString());//借方金额（本币）
//                                hashMap.put("numberField_m33t6vbp", entry.get("enteredcr").toString());//贷方金额（原币）
//                                hashMap.put("numberField_m33t6vbq", entry.get("accountedcr").toString());//贷方金额（本币）
//                                hashMap.put("textField_m33t6vbs", entry.get("sob_code").toString());//所属组织编码
//                                hashMap.put("textField_m33t6vbt", entry.get("sob_name").toString());//所属组织
//                                if (!entry.get("interface_time").toString().equals("")) {
//                                    hashMap.put("dateField_m33t6vbu", dateString_NYRSFM(entry.get("interface_time").toString()));//更新日期
//                                }
//                                hashMap.put("textField_m3sds3p2", UID);//uid
//                                // 构建查询参数
//                                cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
//                                searchCondition.put("textField_m3sds3p2", UID);
//                                ydClient.operateData(YDParam.builder()
//                                        .appType("APP_U3W7R66HBXPW5T4LETZ7")
//                                        .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
//                                        .formUuid("FORM-F4AF927710C34E53A5F2F61BB27B223C2WLL")
//                                        .searchCondition(JSON.toJSONString(searchCondition))
//                                        .formDataJson(JSON.toJSONString(hashMap))
//                                        .build(), YDConf.FORM_OPERATION.upsert);
//
//
//                            }
                        }


                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }
                    i++;//累计个数
                }


            }
        }

        if (false) {
            if (mso != null && mso.size() > 0) {
                int i = 1;
                for (Map<Object, Object> map : mso) {
                    try {
                        log.info("ads_fina_gen_accoutbook_detail_i表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                        System.out.println("ads_fina_gen_accoutbook_detail_i表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                        Map entry = map;//数据写入宜搭
                        String UID = entry.get("uid").toString();
                        if (!UID.equals("")) {
                            // 构建查询参数
                            cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
                            searchCondition.put("textField_m3sds3p2", UID);
                            List<Map> list = (List<Map>) ydClient.queryData(
                                    YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formUuid("FORM-F4AF927710C34E53A5F2F61BB27B223C2WLL")
                                            .searchCondition(JSON.toJSONString(searchCondition))
                                            .build(),
                                    YDConf.FORM_QUERY.retrieve_list).getData();
                            if (list.size() > 0) {//判断UID有数据，就做更新
                                if (true) {
                                    String formInstanceId = list.get(0).get("formInstanceId").toString();
                                    String ZD = "textField_m33t6vai, textField_m33t6vak, textField_m33t6vam, textField_m33t6vao, textField_m33t6vaq, textField_m33t6vat, textField_m33t6vau, textField_m33t6vav, textField_m33t6vaw, textField_m33t6vay, textField_m33t6vb7, textField_m33t6vb9, textField_m33t6vax, ";
                                    ZD += "textField_m33t6vaz, textField_m33t6vb6, textField_m33t6vb8, textField_m33t6vbb, textField_m33t6vbc, textField_m33t6vbd, textField_m3se4z4w, textField_m33t6vbe, textField_m33t6vbf, textField_m33t6vbg, dateField_m33t6vbh, textField_m33t6vbi, textField_m33t6vbj, textField_m33t6vbk, ";
                                    ZD += "numberField_m33t6vbm, numberField_m33t6vbn, numberField_m33t6vbo, numberField_m33t6vbp, numberField_m33t6vbq, textField_m33t6vbs, textField_m33t6vbt, dateField_m33t6vbu, textField_m3sds3p2";
                                    ydClient.operateData(YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formInstanceId(String.valueOf(formInstanceId))
                                            .updateFormDataJson(JSON.toJSONString(UtilMap.map(ZD, entry.get("serialno").toString(), entry.get("year_detail").toString(), entry.get("month_detail").toString(), entry.get("day_detail").toString(), entry.get("account_code").toString(), entry.get("account_name").toString()
                                                    , entry.get("naturalaccount").toString(), entry.get("account_lv").toString(), entry.get("account_code1").toString(), entry.get("account_code2").toString(), entry.get("account_code3").toString(), entry.get("account_code4").toString(), entry.get("account_name1").toString()
                                                    , entry.get("account_name2").toString(), entry.get("account_name3").toString(), entry.get("account_name4").toString(), entry.get("currencycode").toString(), entry.get("currencyname").toString(), entry.get("currencysymbol").toString(), entry.get("last_depart").toString()
                                                    , entry.get("subject_code").toString(), entry.get("leaf_node_name").toString(), entry.get("abstracts").toString(), dateString_NYRSFM(entry.get("createdate").toString()), entry.get("vouchercategorycode").toString(), entry.get("couchercategoryname").toString(), entry.get("vouchercode").toString()
                                                    , entry.get("unitprice").toString(), entry.get("entereddr").toString(), entry.get("accounteddr").toString(), entry.get("enteredcr").toString(), entry.get("accountedcr").toString(), entry.get("sob_code").toString(), entry.get("sob_name").toString(), dateString_NYRSFM(entry.get("interface_time").toString()), UID)))
                                            .build(), YDConf.FORM_OPERATION.update);
                                }
                            } else {// //判断UID无数据，新增
                                if (true) {
                                    Map hashMap = new HashMap();
                                    hashMap.put("textField_m33t6vai", entry.get("serialno").toString());//行号
//                                if (!entry.get("displayname").toString().equals("")) {
//                                    hashMap.put("dateField_m33t6vas", entry.get("displayname").toString().equals("") ? null : entry.get("displayname").toString().equals(""));//时间
//                                }
                                    hashMap.put("textField_m33t6vak", entry.get("year_detail").toString());//年
                                    hashMap.put("textField_m33t6vam", entry.get("month_detail").toString());//月
                                    hashMap.put("textField_m33t6vao", entry.get("day_detail").toString());//日
                                    hashMap.put("textField_m33t6vaq", entry.get("account_code").toString());//科目编码
                                    hashMap.put("textField_m33t6vat", entry.get("account_name").toString());//科目名称
                                    hashMap.put("textField_m33t6vau", entry.get("naturalaccount").toString());//自然客户编码
                                    hashMap.put("textField_m33t6vav", entry.get("account_lv").toString());//客户级别
                                    hashMap.put("textField_m33t6vaw", entry.get("account_code1").toString());//1级科目编码
                                    hashMap.put("textField_m33t6vay", entry.get("account_code2").toString());//2级科目编码
                                    hashMap.put("textField_m33t6vb7", entry.get("account_code3").toString());//3级科目编码
                                    hashMap.put("textField_m33t6vb9", entry.get("account_code4").toString());//4级科目编码
                                    hashMap.put("textField_m33t6vax", entry.get("account_name1").toString());//1级科目名称
                                    hashMap.put("textField_m33t6vaz", entry.get("account_name2").toString());//2级科目名称
                                    hashMap.put("textField_m33t6vb6", entry.get("account_name3").toString());//3级科目名称
                                    hashMap.put("textField_m33t6vb8", entry.get("account_name4").toString());//4级科目名称
                                    hashMap.put("textField_m33t6vbb", entry.get("currencycode").toString());//币种编码
                                    hashMap.put("textField_m33t6vbc", entry.get("currencyname").toString());//币种名称
                                    hashMap.put("textField_m33t6vbd", entry.get("currencysymbol").toString());//币种单位
                                    hashMap.put("textField_m3se4z4w", entry.get("last_depart").toString());//部门末级
                                    hashMap.put("textField_m33t6vbe", entry.get("subject_code").toString());//末级科目编码
                                    hashMap.put("textField_m33t6vbf", entry.get("leaf_node_name").toString());//末级科目名称
                                    hashMap.put("textField_m33t6vbg", entry.get("abstracts").toString());//摘要
                                    hashMap.put("dateField_m33t6vbh", dateString_NYRSFM(entry.get("createdate").toString()));//制单日期
                                    hashMap.put("textField_m33t6vbi", entry.get("vouchercategorycode").toString());//凭证类型编码
                                    hashMap.put("textField_m33t6vbj", entry.get("couchercategoryname").toString());//凭证类型
                                    hashMap.put("textField_m33t6vbk", entry.get("vouchercode").toString());//凭证号
                                    hashMap.put("numberField_m33t6vbm", entry.get("unitprice").toString());//单价
                                    hashMap.put("numberField_m33t6vbn", entry.get("entereddr").toString());//借方金额（原币）
                                    hashMap.put("numberField_m33t6vbo", entry.get("accounteddr").toString());//借方金额（本币）
                                    hashMap.put("numberField_m33t6vbp", entry.get("enteredcr").toString());//贷方金额（原币）
                                    hashMap.put("numberField_m33t6vbq", entry.get("accountedcr").toString());//贷方金额（本币）
                                    hashMap.put("textField_m33t6vbs", entry.get("sob_code").toString());//所属组织编码
                                    hashMap.put("textField_m33t6vbt", entry.get("sob_name").toString());//所属组织
                                    if (!entry.get("interface_time").toString().equals("")) {
                                        hashMap.put("dateField_m33t6vbu", dateString_NYRSFM(entry.get("interface_time").toString()));//更新日期
                                    }
                                    hashMap.put("textField_m3sds3p2", UID);//uid
                                    ydClient.operateData(YDParam.builder()
                                            .appType("APP_U3W7R66HBXPW5T4LETZ7")
                                            .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
                                            .formUuid("FORM-F4AF927710C34E53A5F2F61BB27B223C2WLL")
                                            .formDataJson(JSON.toJSONString(hashMap))
                                            .build(), YDConf.FORM_OPERATION.create);

                                }
                            }
                        }


                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }
                    i++;//累计个数
                }


            }
        }

        if (false) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {
                        String pd = entry.get("year_detail").toString() + entry.get("month_detail").toString() + entry.get("account_code1").toString() + entry.get("account_name1").toString() + entry.get("currencycode").toString() + entry.get("currencyname").toString() + entry.get("last_depart").toString() + entry.get("subject_code").toString() + entry.get("leaf_node_name").toString() + entry.get("abstracts").toString() + entry.get("createdate").toString() + entry.get("couchercategoryname").toString() + entry.get("vouchercode").toString() + entry.get("unitprice").toString() + entry.get("entereddr").toString() + entry.get("accounteddr").toString() + entry.get("sob_name").toString();
                        if (!portal_PNPD.containsKey(pd)) {
                            array[i] = new String[]{(String) entry.get("uid").toString(), (String) entry.get("year_detail").toString(), (String) entry.get("month_detail").toString(), (String) entry.get("day_detail").toString()
                                    , (String) entry.get("account_code").toString(), (String) entry.get("account_name").toString(), (String) entry.get("naturalaccount").toString(), (String) entry.get("account_lv").toString(), (String) entry.get("account_code1").toString(), (String) entry.get("account_code2").toString()
                                    , (String) entry.get("account_code3").toString(), (String) entry.get("account_code4").toString(), (String) entry.get("account_name1").toString(), (String) entry.get("account_name2").toString(), (String) entry.get("account_name3").toString()
                                    , (String) entry.get("account_name4").toString(), (String) entry.get("currencycode").toString(), (String) entry.get("currencyname").toString(), (String) entry.get("currencysymbol").toString(), (String) entry.get("last_depart").toString(), (String) entry.get("subject_code").toString()
                                    , (String) entry.get("leaf_node_name").toString(), (String) entry.get("abstracts").toString(), (String) entry.get("createdate").toString(), (String) entry.get("vouchercategorycode").toString(), (String) entry.get("couchercategoryname").toString()
                                    , (String) entry.get("vouchercode").toString(), (String) entry.get("unitprice").toString(), (String) entry.get("entereddr").toString(), (String) entry.get("accounteddr").toString(), (String) entry.get("enteredcr").toString(), (String) entry.get("accountedcr").toString()
                                    , (String) entry.get("sob_code").toString(), (String) entry.get("sob_name").toString(), (String) entry.get("interface_time").toString()};
                        }

                    }
                    i++;//累计个数
                }
                if (i > 0) {
                    try {

                        String sql = "INSERT INTO ads_ai_pr_allbom_cost_trend_i (uid, receivement, totalmnyfc, iteminfo_itemid, iteminfo_itemcode, iteminfo_itemname, arrivedtime, material_type, interface_time, creation_time)" +
                                "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?,? )";
                        Connection connection = null;
                        PreparedStatement preparedStatement = null;
                        connection = getConnection();
                        preparedStatement = connection.prepareStatement(sql);
                        connection.setAutoCommit(false);
                        int nums = 0;
                        for (String[] row : array) {
                            if (nums < i) {
                                LocalDateTime now = LocalDateTime.now();
                                // 定义日期时间格式化器
                                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                // 格式化日期时间
                                String formattedDateTime = now.format(formatter);
                                preparedStatement.setString(1, row[0]);
                                preparedStatement.setString(2, row[1]);
                                preparedStatement.setString(3, row[2]);
                                preparedStatement.setString(4, row[3]);
                                preparedStatement.setString(5, row[4]);
                                preparedStatement.setString(6, row[5]);
                                preparedStatement.setString(7, row[6]);
                                preparedStatement.setString(8, row[7]);
                                preparedStatement.setString(9, row[8]);
                                preparedStatement.setString(10, formattedDateTime);
                                preparedStatement.addBatch();
                            }
                            nums++;
                        }
                        // Execute batch
                        int[] counts = preparedStatement.executeBatch();
                        connection.commit();
                        System.out.println("ads_ai_pr_allbom_cost_trend_i本次同步完成:Inserted " + counts.length + " rows.");

                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }
                }

                for (Map<Object, Object> map : mso) {
                    try {
                        log.info("ads_fina_gen_accoutbook_detail_i表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                        System.out.println("ads_fina_gen_accoutbook_detail_i表第:" + i + "/" + mso.size() + " 正在同步宜搭！");
                        Map entry = map;//数据写入宜搭
                        String UID = entry.get("uid").toString();
                        String pd = entry.get("year_detail").toString() + entry.get("month_detail").toString() + entry.get("account_code1").toString() + entry.get("account_name1").toString() + entry.get("currencycode").toString() + entry.get("currencyname").toString() + entry.get("last_depart").toString() + entry.get("subject_code").toString() + entry.get("leaf_node_name").toString() + entry.get("abstracts").toString() + entry.get("createdate").toString() + entry.get("couchercategoryname").toString() + entry.get("vouchercode").toString() + entry.get("unitprice").toString() + entry.get("entereddr").toString() + entry.get("accounteddr").toString() + entry.get("sob_name").toString();
                        String enteredcr = entry.get("enteredcr").toString();
                        String accountedcr = entry.get("accountedcr").toString();
                      //  if (!UID.equals("") && enteredcr.equals("0.0") && accountedcr.equals("0.0") && !portal_PNPD.containsKey(pd)) {//2025年0211 改成不需要判断重复
                        if(true){
                            if (true) {
                                portal_PNPD.put(pd, pd);
                                String sql = "INSERT INTO ads_fina_gen_accoutbook_detail_i (UID, year_detail, month_detail, day_detail, account_code, account_name, naturalaccount, account_lv, account_code1, account_code2, account_code3, account_code4, account_name1, account_name2, account_name3, account_name4, currencycode, currencyname, currencysymbol, last_depart, subject_code, leaf_node_name, abstracts, createdate, vouchercategorycode, couchercategoryname, vouchercode, unitprice, entereddr, accounteddr, enteredcr, accountedcr, sob_code, sob_name, interface_time)" +
                                        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
//                                        "ON DUPLICATE KEY UPDATE year_detail = VALUES(year_detail),month_detail = VALUES(month_detail),day_detail = VALUES(day_detail),account_code = VALUES(account_code),account_name = VALUES(account_name),naturalaccount = VALUES(naturalaccount),account_lv = VALUES(account_lv) " +
//                                        ",account_code1 = VALUES(account_code1),account_code2 = VALUES(account_code2),account_code3 = VALUES(account_code3),account_code4 = VALUES(account_code4),account_name1 = VALUES(account_name1),account_name2 = VALUES(account_name2),account_name3 = VALUES(account_name3),account_name4 = VALUES(account_name4)" +
//                                        ",currencycode = VALUES(currencycode),currencyname = VALUES(currencyname),     currencysymbol = VALUES(currencysymbol),last_depart = VALUES(last_depart),subject_code = VALUES(subject_code),leaf_node_name = VALUES(leaf_node_name),abstracts = VALUES(abstracts)" +
//                                        ",createdate = VALUES(createdate),vouchercategorycode = VALUES(vouchercategorycode),couchercategoryname = VALUES(couchercategoryname),vouchercode = VALUES(vouchercode),unitprice = VALUES(unitprice),entereddr = VALUES(entereddr),accounteddr = VALUES(accounteddr)" +
//                                        ",enteredcr = VALUES(enteredcr),accountedcr = VALUES(accountedcr),sob_code = VALUES(sob_code),sob_name = VALUES(sob_name),interface_time = VALUES(interface_time)"; // 替换为你的表和列名
                                Connection connection = null;
                                PreparedStatement preparedStatement = null;
                                try {
                                    connection = getConnection();
                                    preparedStatement = connection.prepareStatement(sql);
                                    preparedStatement.setString(1, UID);
                                    preparedStatement.setString(2, (String) entry.get("year_detail").toString());
                                    preparedStatement.setString(3, (String) entry.get("month_detail").toString());
                                    preparedStatement.setString(4, (String) entry.get("day_detail").toString());
                                    preparedStatement.setString(5, (String) entry.get("account_code").toString());
                                    preparedStatement.setString(6, (String) entry.get("account_name").toString());
                                    preparedStatement.setString(7, (String) entry.get("naturalaccount").toString());
                                    preparedStatement.setString(8, (String) entry.get("account_lv").toString());
                                    preparedStatement.setString(9, (String) entry.get("account_code1").toString());
                                    preparedStatement.setString(10, (String) entry.get("account_code2").toString());
                                    preparedStatement.setString(11, (String) entry.get("account_code3").toString());
                                    preparedStatement.setString(12, (String) entry.get("account_code4").toString());
                                    preparedStatement.setString(13, (String) entry.get("account_name1").toString());
                                    preparedStatement.setString(14, (String) entry.get("account_name2").toString());
                                    preparedStatement.setString(15, (String) entry.get("account_name3").toString());
                                    preparedStatement.setString(16, (String) entry.get("account_name4").toString());
                                    preparedStatement.setString(17, (String) entry.get("currencycode").toString());
                                    preparedStatement.setString(18, (String) entry.get("currencyname").toString());
                                    preparedStatement.setString(19, (String) entry.get("currencysymbol").toString());
                                    preparedStatement.setString(20, (String) entry.get("last_depart").toString());
                                    preparedStatement.setString(21, (String) entry.get("subject_code").toString());
                                    preparedStatement.setString(22, (String) entry.get("leaf_node_name").toString());
                                    preparedStatement.setString(23, (String) entry.get("abstracts").toString());
                                    preparedStatement.setString(24, (String) entry.get("createdate").toString());
                                    preparedStatement.setString(25, (String) entry.get("vouchercategorycode").toString());
                                    preparedStatement.setString(26, (String) entry.get("couchercategoryname").toString());
                                    preparedStatement.setString(27, (String) entry.get("vouchercode").toString());
                                    preparedStatement.setString(28, (String) entry.get("unitprice").toString());
                                    preparedStatement.setString(29, (String) entry.get("entereddr").toString());
                                    preparedStatement.setString(30, (String) entry.get("accounteddr").toString());
                                    preparedStatement.setString(31, (String) entry.get("enteredcr").toString());
                                    preparedStatement.setString(32, (String) entry.get("accountedcr").toString());
                                    preparedStatement.setString(33, (String) entry.get("sob_code").toString());
                                    preparedStatement.setString(34, (String) entry.get("sob_name").toString());
                                    preparedStatement.setString(35, (String) entry.get("interface_time").toString());
                                    int rowsAffected = preparedStatement.executeUpdate();
                                    if (rowsAffected > 0) {
                                        System.out.println("数据插入成功！");
                                    }
                                } catch (SQLException e) {
                                    e.printStackTrace();
                                } finally {
                                    // 确保资源被关闭
                                    try {
                                        if (preparedStatement != null) preparedStatement.close();
                                        if (connection != null) connection.close();
                                    } catch (SQLException ex) {
                                        ex.printStackTrace();
                                    }
                                }
                            }

//                            if (true) {
//                                Map hashMap = new HashMap();
//                                hashMap.put("textField_m33t6vai", entry.get("serialno").toString());//行号
////                                if (!entry.get("displayname").toString().equals("")) {
////                                    hashMap.put("dateField_m33t6vas", entry.get("displayname").toString().equals("") ? null : entry.get("displayname").toString().equals(""));//时间
////                                }
//                                hashMap.put("textField_m33t6vak", entry.get("year_detail").toString());//年
//                                hashMap.put("textField_m33t6vam", entry.get("month_detail").toString());//月
//                                hashMap.put("textField_m33t6vao", entry.get("day_detail").toString());//日
//                                hashMap.put("textField_m33t6vaq", entry.get("account_code").toString());//科目编码
//                                hashMap.put("textField_m33t6vat", entry.get("account_name").toString());//科目名称
//                                hashMap.put("textField_m33t6vau", entry.get("naturalaccount").toString());//自然客户编码
//                                hashMap.put("textField_m33t6vav", entry.get("account_lv").toString());//客户级别
//                                hashMap.put("textField_m33t6vaw", entry.get("account_code1").toString());//1级科目编码
//                                hashMap.put("textField_m33t6vay", entry.get("account_code2").toString());//2级科目编码
//                                hashMap.put("textField_m33t6vb7", entry.get("account_code3").toString());//3级科目编码
//                                hashMap.put("textField_m33t6vb9", entry.get("account_code4").toString());//4级科目编码
//                                hashMap.put("textField_m33t6vax", entry.get("account_name1").toString());//1级科目名称
//                                hashMap.put("textField_m33t6vaz", entry.get("account_name2").toString());//2级科目名称
//                                hashMap.put("textField_m33t6vb6", entry.get("account_name3").toString());//3级科目名称
//                                hashMap.put("textField_m33t6vb8", entry.get("account_name4").toString());//4级科目名称
//                                hashMap.put("textField_m33t6vbb", entry.get("currencycode").toString());//币种编码
//                                hashMap.put("textField_m33t6vbc", entry.get("currencyname").toString());//币种名称
//                                hashMap.put("textField_m33t6vbd", entry.get("currencysymbol").toString());//币种单位
//                                hashMap.put("textField_m3se4z4w", entry.get("last_depart").toString());//部门末级
//                                hashMap.put("textField_m33t6vbe", entry.get("subject_code").toString());//末级科目编码
//                                hashMap.put("textField_m33t6vbf", entry.get("leaf_node_name").toString());//末级科目名称
//                                hashMap.put("textField_m33t6vbg", entry.get("abstracts").toString());//摘要
//                                hashMap.put("dateField_m33t6vbh", dateString_NYRSFM(entry.get("createdate").toString()));//制单日期
//                                hashMap.put("textField_m33t6vbi", entry.get("vouchercategorycode").toString());//凭证类型编码
//                                hashMap.put("textField_m33t6vbj", entry.get("couchercategoryname").toString());//凭证类型
//                                hashMap.put("textField_m33t6vbk", entry.get("vouchercode").toString());//凭证号
//                                hashMap.put("numberField_m33t6vbm", entry.get("unitprice").toString());//单价
//                                hashMap.put("numberField_m33t6vbn", entry.get("entereddr").toString());//借方金额（原币）
//                                hashMap.put("numberField_m33t6vbo", entry.get("accounteddr").toString());//借方金额（本币）
//                                hashMap.put("numberField_m33t6vbp", entry.get("enteredcr").toString());//贷方金额（原币）
//                                hashMap.put("numberField_m33t6vbq", entry.get("accountedcr").toString());//贷方金额（本币）
//                                hashMap.put("textField_m33t6vbs", entry.get("sob_code").toString());//所属组织编码
//                                hashMap.put("textField_m33t6vbt", entry.get("sob_name").toString());//所属组织
//                                if (!entry.get("interface_time").toString().equals("")) {
//                                    hashMap.put("dateField_m33t6vbu", dateString_NYRSFM(entry.get("interface_time").toString()));//更新日期
//                                }
//                                hashMap.put("textField_m3sds3p2", UID);//uid
//                                // 构建查询参数
//                                cn.hutool.json.JSONObject searchCondition = new cn.hutool.json.JSONObject();
//                                searchCondition.put("textField_m3sds3p2", UID);
//                                ydClient.operateData(YDParam.builder()
//                                        .appType("APP_U3W7R66HBXPW5T4LETZ7")
//                                        .systemToken("LG9663B1RMIPG2PGDDLEEB0DK2GK3DRFWGI2ME2N")
//                                        .formUuid("FORM-F4AF927710C34E53A5F2F61BB27B223C2WLL")
//                                        .searchCondition(JSON.toJSONString(searchCondition))
//                                        .formDataJson(JSON.toJSONString(hashMap))
//                                        .build(), YDConf.FORM_OPERATION.upsert);
//
//
//                            }
                        }


                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }
                    i++;//累计个数
                }


            }
        }

    }


    public void ads_ai_pr_allbom_cost_trend_i(List<Map<Object, Object>> mso) {
        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {
                        array[i] = new String[]{(String) entry.get("uid").toString(), (String) entry.get("receivement").toString(), (String) entry.get("totalmnyfc").toString(), (String) entry.get("ItemInfo_ItemID").toString(), (String) entry.get("iteminfo_itemcode").toString()
                                , (String) entry.get("iteminfo_itemname").toString(), (String) entry.get("arrivedtime").toString(), (String) entry.get("material_type").toString(), (String) entry.get("interface_time").toString()};
                    }
                    i++;//累计个数
                }
                if (i > 0) {
                    try {
                        String sql = "INSERT INTO ads_ai_pr_allbom_cost_trend_i (uid, receivement, totalmnyfc, iteminfo_itemid, iteminfo_itemcode, iteminfo_itemname, arrivedtime, material_type, interface_time, creation_time)" +
                                "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?,? )";
                        Connection connection = null;
                        PreparedStatement preparedStatement = null;
                        connection = getConnection();
                        preparedStatement = connection.prepareStatement(sql);
                        connection.setAutoCommit(false);
                        int nums = 0;
                        for (String[] row : array) {
                            if (nums < i) {
                                LocalDateTime now = LocalDateTime.now();
                                // 定义日期时间格式化器
                                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                // 格式化日期时间
                                String formattedDateTime = now.format(formatter);
                                preparedStatement.setString(1, row[0]);
                                preparedStatement.setString(2, row[1]);
                                preparedStatement.setString(3, row[2]);
                                preparedStatement.setString(4, row[3]);
                                preparedStatement.setString(5, row[4]);
                                preparedStatement.setString(6, row[5]);
                                preparedStatement.setString(7, row[6]);
                                preparedStatement.setString(8, row[7]);
                                preparedStatement.setString(9, row[8]);
                                preparedStatement.setString(10, formattedDateTime);
                                preparedStatement.addBatch();
                            }
                            nums++;
                        }
                        // Execute batch
                        int[] counts = preparedStatement.executeBatch();
                        connection.commit();
                        System.out.println("ads_ai_pr_allbom_cost_trend_i本次同步完成:Inserted " + counts.length + " rows.");

                    } catch (Exception a) {
                        log.info(a.toString());
                        System.out.println(a.toString());
                    }

                }
            }
        }

    }

    public void ads_pr_purchase_details_o(List<Map<Object, Object>> mso) {
        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {
                        array[i] = new String[]{(String) entry.get("Purchase_requisition_line_id").toString(), (String) entry.get("Purchase_requisition_head_id").toString(), (String) entry.get("application_line_id").toString(), (String) entry.get("purchase_order_number").toString(), (String) entry.get("tbutocburate").toString()
                                , (String) entry.get("tbutopburate").toString(), (String) entry.get("finallypricefc").toString(), (String) entry.get("netfinallypricefc").toString(), (String) entry.get("TotalMnyFC").toString(), (String) entry.get("rcvorg").toString(), (String) entry.get("tutobomuomrate").toString(), (String) entry.get("bomeffectivedate").toString(),
                                (String) entry.get("bomid").toString(), (String) entry.get("bomowner").toString(), (String) entry.get("bomver").toString(), (String) entry.get("ItemInfo_ItemID").toString(), (String) entry.get("ItemInfo_code").toString(), (String) entry.get("createdby").toString(), (String) entry.get("createdon").toString(), (String) entry.get("modifiedby").toString(),
                                (String) entry.get("modifiedon").toString(), (String) entry.get("BusinessDate").toString(), (String) entry.get("Material_type").toString(), (String) entry.get("line_Status").toString(), (String) entry.get("head_Status").toString(), (String) entry.get("Purchasing_organization").toString(), (String) entry.get("Receiving_organization").toString()
                                , (String) entry.get("PurQtyCU").toString(), (String) entry.get("PurQtyPU").toString(), (String) entry.get("PurQtySU").toString(), (String) entry.get("PurDept").toString(), (String) entry.get("interface_time").toString()
                        };
                        i++;
                    }
                }
                if (i > 0) {
                    String sql = "INSERT INTO ads_pr_purchase_details_o  (Purchase_requisition_line_id, Purchase_requisition_head_id, application_line_id, purchase_order_number, tbutocburate, tbutopburate," +
                            " finallypricefc, netfinallypricefc, TotalMnyFC, rcvorg, tutobomuomrate, bomeffectivedate, bomid, bomowner, bomver, ItemInfo_ItemID, ItemInfo_code, createdby, createdon, modifiedby, " +
                            "modifiedon, BusinessDate, Material_type, line_Status, head_Status, Purchasing_organization, Receiving_organization, PurQtyCU, PurQtyPU, PurQtySU, PurDept, interface_time, creation_time)" +
                            "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? ,?)";
                    Connection connection = null;
                    PreparedStatement preparedStatement = null;
                    try {
                        connection = getConnection();
                        preparedStatement = connection.prepareStatement(sql);

                        connection.setAutoCommit(false);
                        int nums = 0;
                        for (String[] row : array) {
                            if (nums < i) {
                                LocalDateTime now = LocalDateTime.now();
                                // 定义日期时间格式化器
                                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                // 格式化日期时间
                                String formattedDateTime = now.format(formatter);

                                preparedStatement.setString(1, row[0]);
                                preparedStatement.setString(2, row[1]);
                                preparedStatement.setString(3, row[2]);
                                preparedStatement.setString(4, row[3]);
                                preparedStatement.setString(5, row[4]);
                                preparedStatement.setString(6, row[5]);
                                preparedStatement.setString(7, row[6]);
                                preparedStatement.setString(8, row[7]);
                                preparedStatement.setString(9, row[8]);
                                preparedStatement.setString(10, row[9]);
                                preparedStatement.setString(11, row[10]);
                                preparedStatement.setString(12, row[11]);
                                preparedStatement.setString(13, row[12]);
                                preparedStatement.setString(14, row[13]);
                                preparedStatement.setString(15, row[14]);
                                preparedStatement.setString(16, row[15]);
                                preparedStatement.setString(17, row[16]);
                                preparedStatement.setString(18, row[17]);
                                preparedStatement.setString(19, row[18]);
                                preparedStatement.setString(20, row[19]);
                                preparedStatement.setString(21, row[20]);
                                preparedStatement.setString(22, row[21]);
                                preparedStatement.setString(23, row[22]);
                                preparedStatement.setString(24, row[23]);
                                preparedStatement.setString(25, row[24]);
                                preparedStatement.setString(26, row[25]);
                                preparedStatement.setString(27, row[26]);
                                preparedStatement.setString(28, row[27]);
                                preparedStatement.setString(29, row[28]);
                                preparedStatement.setString(30, row[29]);
                                preparedStatement.setString(31, row[30]);
                                preparedStatement.setString(32, row[31]);
                                preparedStatement.setString(33, formattedDateTime);
                                preparedStatement.addBatch();
                            }
                            nums++;
                        }
                        // Execute batch
                        int[] counts = preparedStatement.executeBatch();
                        connection.commit();
                        System.out.println("ads_pr_purchase_details_o 本次同步完成:Inserted " + counts.length + " rows.");

                    } catch (SQLException e) {
                        e.printStackTrace();
                    } finally {
                        // 确保资源被关闭
                        try {
                            if (preparedStatement != null) preparedStatement.close();
                            if (connection != null) connection.close();
                        } catch (SQLException ex) {
                            ex.printStackTrace();
                        }
                    }
                }


            }
        }

    }

    public void ads_ai_pro_raw_material_i(List<Map<Object, Object>> mso) {
        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {
                        String max_date_dh="";
                        if ((String) entry.get("date_dh").toString()!=""){
                            String datesString = (String) entry.get("date_dh").toString();



                            // 使用逗号作为分隔符将字符串分割成数组
                            String[] datesArray = datesString.split(",");

                            // 定义日期格式化器
                            DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

                            // 初始化最大日期为null
                            LocalDate maxDate = null;

                            // 遍历数组中的每个日期字符串
                            for (String dateStr : datesArray) {
                                // 去除日期字符串两侧的空格（如果有的话）
                            if (!dateStr.equals("")){
                                dateStr = dateStr.trim();

                                try {
                                    // 解析日期字符串为LocalDate对象
                                    LocalDate date = LocalDate.parse(dateStr, formatter);

                                    // 如果maxDate为空或者当前日期大于maxDate，则更新maxDate
                                    if (maxDate == null || date.isAfter(maxDate)) {
                                        maxDate = date;
                                    }
                                } catch (DateTimeParseException e) {
                                    // 如果日期格式不正确，则打印错误信息（或者你可以选择其他处理方式）
                                    System.err.println("日期格式不正确: " + dateStr);
                                }
                            }
                            }

                            // 打印最大日期
                            if (maxDate != null) {
                                max_date_dh = String.valueOf(maxDate);
                            }
                        }
                        array[i] = new String[]{(String) entry.get("uid").toString(), (String) entry.get("material_type").toString(), (String) entry.get("PurDept").toString(), (String) entry.get("name_cg").toString(), (String) entry.get("prno").toString(), (String) entry.get("prid").toString()
                                , (String) entry.get("name_pr").toString(), (String) entry.get("date_cg").toString(), (String) entry.get("puroper").toString(), (String) entry.get("name_ywy").toString(), (String) entry.get("docno").toString(), (String) entry.get("doclineno").toString(), (String) entry.get("supplier_name").toString()
                                , (String) entry.get("iteminfo_itemcode").toString(), (String) entry.get("iteminfo_itemname").toString(), (String) entry.get("specs").toString(), (String) entry.get("unit").toString(), (String) entry.get("reqqtypu").toString(), (String) entry.get("finallypricetc").toString(), (String) entry.get("totalmnyfc").toString(), (String) entry.get("bomeffectivedate").toString()
                                , (String) entry.get("date_dh").toString(), (String) entry.get("totalrecievedqtypu").toString(), (String) entry.get("totalmatchedmnytc").toString(), (String) entry.get("businessdate").toString(), (String) entry.get("invoicenum").toString(), (String) entry.get("invoicedate").toString()
                                , (String) entry.get("business_name").toString(), (String) entry.get("maturity").toString(), (String) entry.get("totalmatchedmnytc_1").toString(), (String) entry.get("djtj_date").toString(), (String) entry.get("cwfk_date").toString()
                                , (String) entry.get("script").toString(), (String) entry.get("notes").toString(), (String) entry.get("status").toString(), (String) entry.get("part_dt").toString(), (String) entry.get("interface_time").toString(),max_date_dh
                        };
                        i++;
                    }
                }
                if (i > 0) {
                    String sql = "INSERT INTO ads_ai_pro_raw_material_i  (uid, material_type, PurDept, name_cg, prno, prid, name_pr, date_cg, " +
                            "PurOper, name_ywy, DocNo, DocLineNo, Supplier_Name, iteminfo_itemcode, iteminfo_itemname, specs, unit, reqqtypu, finallypricetc," +
                            " totalmnyfc, bomeffectivedate, date_dh, TotalRecievedQtyPU, totalmatchedmnytc, businessdate, invoicenum, invoicedate, business_name," +
                            " maturity, totalmatchedmnytc_1, djtj_date, cwfk_date, script, notes, status, part_dt, interface_time, creation_time, max_date_dh)" +
                            "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?)";
                    Connection connection = null;
                    PreparedStatement preparedStatement = null;
                    try {
                        connection = getConnection();
                        preparedStatement = connection.prepareStatement(sql);
                        connection.setAutoCommit(false);
                        int nums = 0;
                        for (String[] row : array) {
                            if (nums < i) {
                                LocalDateTime now = LocalDateTime.now();
                                // 定义日期时间格式化器
                                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                // 格式化日期时间
                                String formattedDateTime = now.format(formatter);
                                preparedStatement.setString(1, row[0]);
                                preparedStatement.setString(2, row[1]);
                                preparedStatement.setString(3, row[2]);
                                preparedStatement.setString(4, row[3]);
                                preparedStatement.setString(5, row[4]);
                                preparedStatement.setString(6, row[5]);
                                preparedStatement.setString(7, row[6]);
                                preparedStatement.setString(8, row[7]);
                                preparedStatement.setString(9, row[8]);
                                preparedStatement.setString(10, row[9]);
                                preparedStatement.setString(11, row[10]);
                                preparedStatement.setString(12, row[11]);
                                preparedStatement.setString(13, row[12]);
                                preparedStatement.setString(14, row[13]);
                                preparedStatement.setString(15, row[14]);
                                preparedStatement.setString(16, row[15]);
                                preparedStatement.setString(17, row[16]);
                                preparedStatement.setString(18, row[17]);
                                preparedStatement.setString(19, row[18]);
                                preparedStatement.setString(20, row[19]);
                                preparedStatement.setString(21, row[20]);
                                preparedStatement.setString(22, row[21]);
                                preparedStatement.setString(23, row[22]);
                                preparedStatement.setString(24, row[23]);
                                preparedStatement.setString(25, row[24]);
                                preparedStatement.setString(26, row[25]);
                                preparedStatement.setString(27, row[26]);
                                preparedStatement.setString(28, row[27]);
                                preparedStatement.setString(29, row[28]);
                                preparedStatement.setString(30, row[29]);
                                preparedStatement.setString(31, row[30]);
                                preparedStatement.setString(32, row[31]);
                                preparedStatement.setString(33, row[32]);
                                preparedStatement.setString(34, row[33]);
                                preparedStatement.setString(35, row[34]);
                                preparedStatement.setString(36, row[35]);
                                preparedStatement.setString(37, row[36]);
                                preparedStatement.setString(38, formattedDateTime);
                                preparedStatement.setString(39, row[37]);
                                preparedStatement.addBatch();
                            }
                            nums++;
                        }
                        // Execute batch
                        int[] counts = preparedStatement.executeBatch();
                        connection.commit();
                        System.out.println("ads_ai_pro_raw_material_i本次同步完成:Inserted " + counts.length + " rows.");
                    } catch (SQLException e) {
                        e.printStackTrace();
                    } finally {
                        // 确保资源被关闭
                        try {
                            if (preparedStatement != null) preparedStatement.close();
                            if (connection != null) connection.close();
                        } catch (SQLException ex) {
                            ex.printStackTrace();
                        }
                    }
                }


            }
        }


    }

    public void ads_pr_application_details_i(List<Map<Object, Object>> mso) {
        if (true) {
            if (mso != null && mso.size() > 0) {
                int i = 0;
                String[][] array = new String[5000][];
                for (Map<Object, Object> map : mso) {
                    Map entry = map;//数据写入宜搭
                    if (true) {
                        array[i] = new String[]{(String) entry.get("u_id").toString(), (String) entry.get("application_line_id").toString(), (String) entry.get("line_status").toString(), (String) entry.get("purdept").toString()
                                , (String) entry.get("material_type").toString(), (String) entry.get("createdon").toString(), (String) entry.get("interface_time").toString()
                        };
                        i++;
                    }
                }

                if (i > 0) {

                    if (true) {
                        String sql = "INSERT INTO ads_pr_application_details_i  (u_id, application_line_id, line_status, purdept, material_type, createdon, interface_time, creation_time)" +
                                "VALUES (?, ?, ?, ?, ?, ?, ?,?)";
                        Connection connection = null;
                        PreparedStatement preparedStatement = null;
                        try {
                            connection = getConnection();
                            preparedStatement = connection.prepareStatement(sql);
                            connection.setAutoCommit(false);
                            int nums = 0;
                            for (String[] row : array) {
                                if (nums < i) {
                                    LocalDateTime now = LocalDateTime.now();
                                    // 定义日期时间格式化器
                                    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
                                    // 格式化日期时间
                                    String formattedDateTime = now.format(formatter);
                                    preparedStatement.setString(1, row[0]);
                                    preparedStatement.setString(2, row[1]);
                                    preparedStatement.setString(3, row[2]);
                                    preparedStatement.setString(4, row[3]);
                                    preparedStatement.setString(5, row[4]);
                                    preparedStatement.setString(6, row[5]);
                                    preparedStatement.setString(7, row[6]);
                                    preparedStatement.setString(8, formattedDateTime);
                                    preparedStatement.addBatch();
                                }
                                nums++;
                            }
                            int[] counts = preparedStatement.executeBatch();
                            connection.commit();
                            System.out.println("ads_pr_application_details_i本次同步完成:Inserted " + counts.length + " rows.");
                        } catch (SQLException e) {
                            e.printStackTrace();
                        } finally {
                            // 确保资源被关闭
                            try {
                                if (preparedStatement != null) preparedStatement.close();
                                if (connection != null) connection.close();
                            } catch (SQLException ex) {
                                ex.printStackTrace();
                            }
                        }
                    }
                }


            }
        }


    }


    private Map portal_PNPD = new HashMap();

    public List<Map<Object, Object>> sendGetRequest_ALL(Map<String, String> params) throws Exception {
        portal_PNPD = new HashMap();
        int pagenum = 1;
        Map map = new HashMap<>();
        List<Map<Object, Object>> allResults = new ArrayList<>();
        params.put("pageNum", String.valueOf(pagenum));
        params.put("pageSize", "5000");
        // 递归调用，直到没有更多页需要获取
        List<Map> currentPageResults = sendGetRequest(params, pagenum);
        //if (pagenum == 1) {
        while (!currentPageResults.isEmpty()) { // 假设空列表表示没有更多页
            allResults = new ArrayList<>();
            System.out.println("正在读取" + params.get("tablename") + "表第:" + pagenum + " 页数据！");
            log.info("正在读取" + params.get("tablename") + "表第:" + pagenum + " 页数据！");
            for (Map<String, Object> entry : currentPageResults) {
                Map<Object, Object> convertedEntry = new HashMap<>();
                for (Map.Entry<String, Object> e : entry.entrySet()) {
                    convertedEntry.put(e.getKey(), e.getValue()); // 这里直接转换，但实际上键可能不需要转换
                }
                convertedEntry.put("parms", pagenum);

                allResults.add(convertedEntry); // 添加到总结果列表中
            }
            String tablename = params.get("tablename");
            if (tablename.equals("ads_hr_work_hours_sub_o")) {
                this.ads_hr_work_hours_sub_o(allResults);
            }
            if (tablename.equals("ads_hr_work_hours_sum_o")) {
                this.ads_hr_work_hours_sum_o(allResults);
            }
            if (tablename.equals("dwd_sal_ship_order_det_i")) {
                this.dwd_sal_ship_order_det_i(allResults);
            }
            if (tablename.equals("ads_fin_gross_profit_margin_i")) {

                this.ads_fin_gross_profit_margin_i(allResults);
            }
            if (tablename.equals("ads_fina_gen_accoutbook_detail_i")) {
                this.ads_fina_gen_accoutbook_detail_i(allResults);
            }
            if (tablename.equals("ads_ai_pr_allbom_cost_trend_i")) {
                this.ads_ai_pr_allbom_cost_trend_i(allResults);
            }
            if (tablename.equals("ads_pr_purchase_details_o")) {
                this.ads_pr_purchase_details_o(allResults);
            }
            if (tablename.equals("ads_ai_pro_raw_material_i")) {
                this.ads_ai_pro_raw_material_i(allResults);
            }
            if (tablename.equals("ads_pr_application_details_i")) {
                this.ads_pr_application_details_i(allResults);
            }
            pagenum++; // 移动到下一页
            currentPageResults = sendGetRequest(params, pagenum); // 获取下一页的结果
        }
        // }
        return allResults; // 返回所有页的结果

    }

    public static List<Map>
    sendGetRequest(Map<String, String> params, int pageNum) throws Exception {
        List<Map> rst = new ArrayList<>();
        try {
            log.info("执行数据库！");
            System.out.println("执行数据库！");
            // 创建一个CookieStore
            CookieStore cookieStore = new BasicCookieStore();
            // 创建一个 Httpclient 实例
            CloseableHttpClient httpclient = HttpClients.custom().setDefaultCookieStore(cookieStore).build();
            // 调用登录接口，保存 Cookie
          String ip = "ays.pyloncloud.com";
            //  String ip = "172.20.20.37";
            HttpPost loginRequest = new HttpPost("http://" + ip + ":7000/uaa/login?username=cubehr&password=cubehr&tenantCode=ZETATECH&accountType=USER&clientType=PC");

            httpclient.execute(loginRequest);
            // 调用其他接口，带上之前保存的 cookie
            HttpGet otherRequest = new HttpGet("http://" + ip + ":70/dataservice/scheduler/bds/v1/execute/" + params.get("connectortype") + "?appId=" + params.get("appId") + "&pageNum=" + pageNum + "&pageSize=" + params.get("pageSize") + "&tablename=" + params.get("tablename") + "&schemalname=" + params.get("schemalname"));
            otherRequest.setHeader("appToken", params.get("appToken"));
            CloseableHttpResponse otherResponse = httpclient.execute(otherRequest);
            // 打印其他接口的响应结果
            JSONObject jsonObject = JSONObject.parseObject(EntityUtils.toString(otherResponse.getEntity(), "UTF-8"));
            log.info("jsonObject:" + jsonObject + "!");
            if (jsonObject.get("msg").equals("ok")) {
                com.alibaba.fastjson.JSONObject jsonObject_data = JSON.parseObject(String.valueOf(jsonObject.get("data")));
                //  System.out.println("jsonObject_data" + jsonObject_data);
                if (jsonObject_data.get("message").equals("查询成功") && jsonObject_data.get("status").equals("执行成功")) {
                    System.out.println("第:" + pageNum + "," + jsonObject_data.get("message") + "!");
                    log.info("第:" + pageNum + "," + jsonObject_data.get("message") + "!");
                    JSONArray jsonArray_data = new JSONArray(jsonObject_data.get("data"));//data值
                    JSONArray columns = new JSONArray(jsonObject_data.get("columns"));//对应的key
                    for (int i = 0; i < jsonArray_data.size(); i++) {
                        // 获取当前遍历到的JSONArray（实际上是一个一维数组）
                        JSONArray innerArray = jsonArray_data.getJSONArray(i);
                        Map<Object, Object> map_get = new HashMap<>();
                        // 遍历这个一维数组
                        for (int j = 0; j < innerArray.size(); j++) {
                            // 获取并打印当前元素
                            String data_value = (String) innerArray.get(j);
                            Map<String, String> data_map = (Map<String, String>) columns.get(j);
                            String data_key = data_map.get("name");
                            if (map_get.containsKey(data_key) && !map_get.get(data_key).equals("")) {  //UID存在多个  ，判断key是否已经存入，如果已经存入 并且不为空 就跳过 否则就存入map
                            } else {
                                map_get.put(data_key, data_value);//key -value 对应
                            }

                        }
                        rst.add(map_get);
                        // 如果需要在每行元素之后打印一个空行（可选）

                    }
                }


            } else {
                System.out.println(jsonObject.get("message"));
                log.info((String) jsonObject.get("message"));
            }
            System.out.println(EntityUtils.toString(otherResponse.getEntity(), "UTF-8"));
            // 关闭 Httpclient
            httpclient.close();
        } catch (Exception e) {
            log.info(e.toString());
        }
        return rst;
    }


    public static Long stringtotime(Long adjustedTimestamp) {


        // 将调整后的时间戳转换回原始的UNIX时间戳（秒为单位）
        long originalTimestampInSeconds = adjustedTimestamp * 1000 - 8 * 3600 * 1000;
        // 将原始的UNIX时间戳（秒为单位）转换为Java中的毫秒时间戳
        // long originalTimestampInMillis = originalTimestampInSeconds * 1000;
        return originalTimestampInSeconds;


    }


    public static String longtimeToDate(Long timestamp) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date(timestamp);
        String formattedDate = sdf.format(date);

        return formattedDate;
    }


    public static String getYear(long timestamp) {
        return LocalDate.ofEpochDay(timestamp).getYear() + "";
    }

    public static int getQuarter(long timestamp) {
        // 将时间戳转换为Date对象
        Date date = new Date(timestamp);
        // 使用Calendar类来获取日期的字段
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        // 获取季度
        return calendar.get(Calendar.MONTH) / 3 + 1;
    }

    public static int getMonth(long timestamp) {
        // 将时间戳转换为Date对象
        Date date = new Date(timestamp);
        // 使用Calendar类来获取日期的字段
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        // 获取季度
        return calendar.get(Calendar.MONTH) + 1;
    }

    public Long dateString_NY(String dateString) throws ParseException {

        // 假设您要转换的日期字符串
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM"); // 设定日期格式
        Date date = formatter.parse(dateString); // 解析字符串为Date对象
        Long timestamp = date.getTime(); // 获取时间戳
        return timestamp;

    }

    public Long dateString_NYRSFM(String dateString) throws ParseException {

        // 假设您要转换的日期字符串
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS"); // 设定日期格式
        Date date = formatter.parse(dateString); // 解析字符串为Date对象
        Long timestamp = date.getTime(); // 获取时间戳
        return timestamp;

    }

    public Long dateString_NYR(String dateString) throws ParseException {

        // 假设您要转换的日期字符串
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd"); // 设定日期格式
        Date date = formatter.parse(dateString); // 解析字符串为Date对象
        Long timestamp = date.getTime(); // 获取时间戳
        return timestamp;

    }


    public static Connection getConnection() throws SQLException {
        return DriverManager.getConnection(url, username, password);
    }

    public static void insertData(Map entry, String sql) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;

        try {
            connection = getConnection();
            preparedStatement = connection.prepareStatement(sql);
            int count = 1;
            for (Object value : entry.values()) {
                preparedStatement.setString(count, (String) value);
                count++;
            }


            int rowsAffected = preparedStatement.executeUpdate();
            if (rowsAffected > 0) {
                System.out.println("数据插入成功！");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            // 确保资源被关闭
            try {
                if (preparedStatement != null) preparedStatement.close();
                if (connection != null) connection.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }

    }
}
